BEGIN TRANSACTION;
CREATE TABLE chatlog
(
    id_conferencia  int NOT NULL,
    id_secuencia    INTEGER NOT NULL,
    id_invitado     int,
    fecha           datetime    NOT NULL,

    mensaje         TEXT,

    PRIMARY KEY (id_secuencia),
    FOREIGN KEY (id_conferencia) REFERENCES conferencia(id_conferencia),
    FOREIGN KEY (id_invitado)    REFERENCES invitado(id_invitado)
);

CREATE TABLE conferencia
(
    id_conferencia  INTEGER         NOT NULL,
    nombre          varchar(64)     NOT NULL,
    fecha_inicio    datetime        NOT NULL,
    fecha_final     datetime        NOT NULL,
    tema            varchar(128)    NOT NULL,
    id_cbmysql_conference int unsigned,

    PRIMARY KEY (id_conferencia)
);

CREATE TABLE docrepo
(
    id_documento    INTEGER     NOT NULL, 
    id_conferencia  INTEGER     NOT NULL,
    nombre_doc      varchar(128)    NOT NULL,
    mime_type       varchar(64) NOT NULL,
    nombre_original varchar(128)    NOT NULL, 
    fecha_upload    datetime    NOT NULL,
    id_invitado_upload int      NOT NULL,

    PRIMARY KEY (id_documento),
    FOREIGN KEY (id_conferencia) REFERENCES conferencia(id_conferencia),
    FOREIGN KEY (id_invitado_upload)    REFERENCES invitado(id_invitado)
);

CREATE TABLE documento
(
    id_documento    INTEGER     NOT NULL, 
    id_conferencia  INTEGER     NOT NULL,
    nombre_doc      varchar(128)    NOT NULL, 
    ruta_directorio_imgs    varchar(128)    NOT NULL, 
    num_paginas     int unsigned    NOT NULL, 

    PRIMARY KEY (id_documento),
    FOREIGN KEY (id_conferencia) REFERENCES conferencia(id_conferencia)
);

CREATE TABLE invitado
(
    id_invitado     INTEGER NOT NULL,
    id_conferencia  INTEGER NOT NULL,
    nick            varchar(128) NOT NULL,
    email           varchar(128) NOT NULL,
    password        varchar(32)  NOT NULL,
    es_creador      tinyint(1)  NOT NULL    DEFAULT 0,
    es_presentador  tinyint(1)  NOT NULL    DEFAULT 0,
    logoneado       tinyint(1)  NOT NULL    DEFAULT 0,
    fecha_ultima_actividad datetime,
    fecha_cierre datetime,

    PRIMARY KEY (id_invitado),
    FOREIGN KEY (id_conferencia) REFERENCES conferencia(id_conferencia)
);

CREATE TABLE presentacion
(
    id_presentacion INTEGER     NOT NULL,
    id_documento    INTEGER     NOT NULL,
    id_conferencia  INTEGER     NOT NULL,
    pag_actual      int unsigned    NOT NULL,

    PRIMARY KEY (id_presentacion),
    FOREIGN KEY (id_documento)  REFERENCES documento(id_documento),
    FOREIGN KEY (id_conferencia) REFERENCES conferencia(id_conferencia)
);

COMMIT;