<?php
/* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 0.5                                                  |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id:  $ */
$DocumentRoot = "/var/www/html";
$DBRoot = "/var/www/db";

require_once "$DocumentRoot/libs/paloSantoInstaller.class.php";
include_once("$DocumentRoot/libs/paloSantoDB.class.php");

$tmpDir = '/tmp/new_module';  # in this folder the load module extract the package content
$return = 1;
$sRutaInstaller = "$tmpDir/setup/";
$arrConsole = $flagStatus = NULL;

$bRequiereSudo = (posix_getuid() != 0);

// Missing conference.php indicates RPM install
if (file_exists("$sRutaInstaller/conference.php")) {
    // Copy conference.php to document root
    print "Conference Room installer: copying conference.php to $DocumentRoot/ ...\n";
    if ($bRequiereSudo) exec("sudo -u root chmod 777 $DocumentRoot",$arrConsole,$flagStatus);
    exec("cp $sRutaInstaller/conference.php $DocumentRoot/",$arrConsole,$flagStatus);
    if ($bRequiereSudo) exec("sudo -u root chmod 755 $DocumentRoot",$arrConsole,$flagStatus);
    $return = ($flagStatus) ? 2:0; if ($return) exit($return);
} elseif (file_exists("$DocumentRoot/conference.php")) {
    print "Conference Room installer: no conference.php, assuming RPM install.\n";
    $return = 0;
} else {
    print "ERR: no conference.php found anywhere!\n";
    exit(1);
}

// Missing conference.php indicates RPM install
/*
if (file_exists("$sRutaInstaller/conferencechat.php")) {
    // Copy conference.php to document root
    print "Conference Room installer: copying conferencechat.php to $DocumentRoot/ ...\n";
    if ($bRequiereSudo) exec("sudo -u root chmod 777 $DocumentRoot",$arrConsole,$flagStatus);
    exec("cp $sRutaInstaller/conferencechat.php $DocumentRoot/",$arrConsole,$flagStatus);
    if ($bRequiereSudo) exec("sudo -u root chmod 755 $DocumentRoot",$arrConsole,$flagStatus);
    $return = ($flagStatus) ? 2:0; if ($return) exit($return);
} elseif (file_exists("$DocumentRoot/conferencechat.php")) {
    print "Conference Room installer: no conferencechat.php, assuming RPM install.\n";
    $return = 0;
} else {
    print "ERR: no conferencechat.php found anywhere!\n";
    exit(1);
}
*/

// Copy theme to theme folder
if (file_exists("$sRutaInstaller/themes/conference")) {
    print "Conference Room installer: copying theme folder to $DocumentRoot/themes/ ...\n";
    if ($bRequiereSudo) exec("sudo -u root chmod 777 $DocumentRoot/themes",$arrConsole,$flagStatus);
    exec("cp -r $sRutaInstaller/themes/conference $DocumentRoot/themes/",$arrConsole,$flagStatus);
    if ($bRequiereSudo) exec("sudo -u root chmod 755 $DocumentRoot/themes",$arrConsole,$flagStatus);
    $return = ($flagStatus) ? 2:0; if ($return) exit($return);
} elseif (file_exists("$DocumentRoot/themes/conference")) {
    print "Conference Room installer: no themes folder, assuming RPM install.\n";
    $return = 0;
} else {
    print "ERR: no themes folder found anywhere!\n";
    exit(1);
}
exit($return);
?>
