<?php 
/* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 0.5                                                  |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: index.php,v 1.3 2007/07/17 00:03:42 gcarrillo Exp $ */

include_once("libs/misc.lib.php");
include_once "configs/default.conf.php";
include_once "libs/paloSantoNavigation.class.php"; 
include_once "libs/paloSantoDB.class.php";
include_once("libs/paloSantoACL.class.php");

// Load xajax
require_once ('libs/xajax/xajax.inc.php');

// Interfaz con Red5
require_once ('SabreAMF/Client.php');

session_name("elastixSession_Conference");
session_start();

load_language();

// Load smarty 
require_once("libs/smarty/libs/Smarty.class.php");
$smarty = new Smarty();

$_global_xajax = new xajax();
function & getXajax()
{
    global $_global_xajax;
    return $_global_xajax;
}

// La plantilla de la conferencia se mantiene separada de la plantilla usada por
// Elastix. Para evitar colisiones con los archivos de plantillas compiladas, se
// crean directorios personalizados para las plantillas
$sDirTemplates = '/tmp/conference_Smarty_templates_c';
$sDirCache = '/tmp/conference_Smarty_cache';
if (!is_dir($sDirTemplates) && !mkdir($sDirTemplates)) die('Unable to create new template directory');
if (!is_dir($sDirCache) && !mkdir($sDirCache)) die('Unable to create new template directory');

$arrConf['mainTheme'] = 'conference';
$smarty->template_dir = "themes/" .$arrConf['mainTheme'];
$smarty->compile_dir =  /*"var/templates_c/"*/ $sDirTemplates;
$smarty->config_dir =   "configs/";
$smarty->cache_dir =    /*"var/cache/"*/ $sDirCache;

$base_dir=dirname($_SERVER['SCRIPT_FILENAME']);

//folder path for custom templates
$templates_dir=(isset($arrConf['templates_dir']))?$arrConf['templates_dir']:'themes';
$local_templates_dir="$base_dir/modules/conferenceroom_list/".$templates_dir.'/'.$arrConf['theme'];

$pDB = new paloDB($arrConf['elastix_dsn']['acl']);

if(!empty($pDB->errMsg)) {
    echo "ERROR DE DB: $pDB->errMsg <br>";
}

$pACL = new paloACL($pDB);

$module_name = 'conferenceroom_list';
include_once "modules/$module_name/configs/default.conf.php";
include_once "modules/$module_name/libs/paloSantoCreateConference.class.php";
include_once "modules/$module_name/libs/paloSantoConferenceChat.class.php";

$arrConf = array_merge($arrConf,$arrConfModule);

load_language_module($module_name);

$pDBConf = new paloDB($arrConf['dsn_conn_database']);
$pConf = new paloSantoCreateConference($pDBConf);
$listaConf = $pConf->listarConferenciasActivas();

$pChat = new paloSantoConferenceChat($pDBConf);

if(isset($_GET['logout']) && $_GET['logout']=='yes') {
    if (isset($_SESSION['elastix_user_id']) && isset($_SESSION['elastix_conference_id'])) {
        $pConf->marcarInvitadoLogin($_SESSION['elastix_conference_id'], $_SESSION['elastix_user_id'], FALSE);
        $pChat->agregarEventoChat($_SESSION['elastix_conference_id'], 'logout '.$_SESSION['elastix_user_nick']);
    }
    session_destroy();
    session_name("elastixSession_Conference");
    session_start();
    Header("Location: conference.php");
}
if(isset($_POST['submit_login']) and !empty($_POST['input_user']) && !empty($_POST['input_conference'])) {
    $infoInvitado = $pConf->leerInvitadoConferencia($_POST['input_conference'], $_POST['input_user']);
    if (!is_null($infoInvitado['fecha_cierre'])) $infoInvitado = NULL;

    // Verificar que la conferencia existe
    if (!isset($listaConf[$_POST['input_conference']])) {
        $smarty->assign("mb_message", 'Selected conference does not exists, or has already expired.');
    } elseif ($_POST['input_pass'] != $infoInvitado['password']) {
        $smarty->assign("mb_message", 'Invalid password for selected user.');
    } else {
        // La conferencia sí existe. Se intenta ingresar el usuario a la base de datos
        if (trim($_POST['input_nick']) == '') $_POST['input_nick'] = $_POST['input_user'];
        $bResult = $pConf->actualizarNickInvitado($_POST['input_conference'], $_POST['input_user'], $_POST['input_nick']);
        if (!$bResult) {
            $smarty->assign("mb_message", $pConf->errMsg);
        } else {
            $_SESSION['elastix_user'] = "";


            $_SESSION['elastix_user_id'] = $infoInvitado['id_invitado'];
            $_SESSION['elastix_user_nick'] = $_POST['input_nick'];
            $_SESSION['elastix_conference_id'] = $_POST['input_conference'];
            
            $pConf->marcarInvitadoLogin($_SESSION['elastix_conference_id'], $_SESSION['elastix_user_id'], TRUE);
            $pChat->agregarEventoChat($_SESSION['elastix_conference_id'], 'login '.$_SESSION['elastix_user_nick']);
        }
    }
}

$bAutenticado = (isset($_SESSION['elastix_user_id']) && isset($_SESSION['elastix_conference_id']));
if (!$bAutenticado) {
    $smarty->assign("THEMENAME", $arrConf['mainTheme']);
    $smarty->assign("PAGE_NAME", _tr('Login page'));
    $smarty->assign("WELCOME", _tr('Welcome to Elastix'));
    $smarty->assign("ENTER_USER_PASSWORD", _tr('Please enter your username and password'));
/*    $smarty->assign("ENTER_USER_PASSWORD", 'Please select a nick and a conference room');*/
    $smarty->assign("LABEL_CONFERENCEROOM", 'Conference room');
    $smarty->assign("USERNAME", _tr('Nick (optional)'));
    $smarty->assign("PASSWORD", _tr('Password'));
    $smarty->assign("SUBMIT", _tr('Submit'));

    $idConferencia = NULL; $idInvitado = NULL;
    if (isset($_GET['conference_id']) && isset($listaConf[$_GET['conference_id']])) {
        $smarty->assign('PROVIDED_CONFID', 1);
        $idConferencia = $_GET['conference_id'];
    }
    if (isset($_GET['id_user'])) {
        $smarty->assign('PROVIDED_USERID', 1);
        $idInvitado = $_GET['id_user'];
    }

//    if (isset($_GET['nick'])) $smarty->assign('INPUT_USER', $_GET['nick']);
    if (!is_null($idConferencia))  {
        $smarty->assign('INPUT_CONFERENCE', $idConferencia);
        $smarty->assign('CONFERENCEROOM', $listaConf[$idConferencia]);
    } else {
        $smarty->assign('INPUT_CONFERENCE', '');
        $smarty->assign('CONFERENCEROOM', 'Invalid Conference ID');
    }

    // Recoger el ID de usuario y verificar si existe
    $infoInvitado = $pConf->leerInvitadoConferencia($idConferencia, $idInvitado);
    if (!is_null($infoInvitado['fecha_cierre'])) $infoInvitado = NULL;

    $smarty->assign('INPUT_USER', $idInvitado);
    if (is_null($infoInvitado)) {
        $smarty->assign('USER_EMAIL', '');
        $smarty->assign('INPUT_NICK', '');
        $smarty->assign('PRIVILEGE', '(none)');
    } else {
        $smarty->assign('USER_EMAIL', $infoInvitado['email']);
        $smarty->assign('INPUT_NICK', $infoInvitado['nick']);
        $sPrivilege = '';
        if (!$infoInvitado['es_creador'] && !$infoInvitado['es_presentador']) {
            $sPrivilege = 'Guest';
        } else {
            if ($infoInvitado['es_creador']) $sPrivilege .= 'Host' . ' ';
            if ($infoInvitado['es_presentador']) $sPrivilege .= 'Presenter' . ' ';
        }
        $smarty->assign('PRIVILEGE', $sPrivilege);
    }

    $smarty->display("$local_templates_dir/login.tpl");
} else {

    $infoInvitado = $pConf->leerInvitadoConferencia($_SESSION['elastix_conference_id'], $_SESSION['elastix_user_id']);

    $smarty->assign('elastix_user_nick', $_SESSION['elastix_user_nick']);
    $privilegios = array();
    if ($infoInvitado['es_creador']) $privilegios[] = _tr('creator');
    if ($infoInvitado['es_presentador']) $privilegios[] = _tr('presentator');
    if (count($privilegios) <= 0) $privilegios[] = _tr('guest');

    $smarty->assign('user_privileges', join(',', $privilegios));
            
    // Mensajes para chat en tiempo real
    $_global_xajax->waitCursorOff();
    $_global_xajax->registerFunction('confChat_queryMessages');
    $_global_xajax->registerFunction('confChat_postMessage');
    $_global_xajax->registerFunction('confChat_changeVideo');

    $arrMenuFiltered = $_SESSION['elastix_user_permission'] = array(
        'conferenceroom_presentation'   =>  array(
            'id'        =>  'conferenceroom_presentation',
            'IdParent'  =>  'conferenceroom',
            'Link'      =>  NULL,
            'Name'      =>  'Presentation',
            'Type'      =>  'module',
            'HasChild'  =>  false,
            'Icon'      =>  'images/conference.png',
        ),
        'conferenceroom_docrepo'   =>  array(
            'id'        =>  'conferenceroom_docrepo',
            'IdParent'  =>  'conferenceroom',
            'Link'      =>  NULL,
            'Name'      =>  'Document repository',
            'Type'      =>  'module',
            'HasChild'  =>  false,
            'Icon'      =>  'images/conference.png',
        ),
        'conferenceroom'   =>  array(
            'id'        =>  'conferenceroom',
            'IdParent'  =>  NULL,
            'Link'      =>  NULL,
            'Name'      =>  'Conference Room',
            'Type'      =>  'module',
            'HasChild'  =>  TRUE,
        ),
    );

    //traducir el menu al idioma correspondiente
    foreach($arrMenuFiltered as $idMenu=>$arrMenuItem) {
        $arrMenuFiltered[$idMenu]['Name'] = _tr($arrMenuItem['Name']);
    }

    $smarty->assign("THEMENAME", $arrConf['mainTheme']);
    $smarty->assign("ABOUT_ELASTIX", _tr('About Elastix')." ".$arrConf['elastix_version']);
    $smarty->assign("ABOUT_ELASTIX_CONTENT", _tr('About Elastix Content'));
    $smarty->assign("ABOUT_CLOSED", _tr('About Elastix Closed'));
    $smarty->assign("LOGOUT",    _tr('Logout'));

    //$menu= (isset($_GET['menu']))?$_GET['menu']:'';
    if(isset($_GET['menu'])) $menu=$_GET['menu'];
    elseif(empty($menu) and !empty($_SESSION['menu'])) $menu=$_SESSION['menu'];
    else $menu='';

    $oPn = new paloSantoNavigation($arrMenuFiltered, $smarty, $menu);
    $_SESSION['menu'] = $oPn->getSelectedModule(); 
 
    $oPn->renderMenuTemplates();

    // rawmode es un modo de operacion que pasa directamente a la pantalla la salida
    // del modulo. Esto es util en ciertos casos.
    if(isset($_GET['rawmode']) && $_GET['rawmode']=='yes') {
        echo $oPn->showContent();
    } else {
        $smarty->assign("CONTENT",   $oPn->showContent());
        $smarty->assign('EXTRA_CONTENT',  procesarChat($arrConf, $pDBConf, $pConf, $smarty));
        $smarty->display("_common/index.tpl");
    }
}

/*

Funcionamiento del módulo de chat de conferencia
------------------------------------------------

Al cargar inicialmente la página, se obtiene el log completo del chat desde la
base de datos, y se llena con él la etiqueta <div> que tiene el chat pasado de
la conferencia. Con esta carga se obtiene también el ID de secuencia más 
reciente de los mensajes escritos, que se asigna al widget HIDDEN de nombre
seq_chat.

Inmediatamente se manda a llamar un método AJAX que interroga los cambios 
realizados, y que envía el valor de seq_chat al servidor. Este método deja 
esperando al navegador, y revisa la base cada 3 segundos para buscar nuevos 
mensajes agregados al log del chat. Si luego de 1 minuto, no hay cambios, el 
método regresa sin más cambios, y es vuelto a invocar por el navegador. En caso
de que hayan cambios, se toman todos los cambios hasta el más reciente, y se
generan sendos mensajes para actualizar el <div> del chat.

Para escribir un nuevo mensaje, se invoca un método AJAX que agrega el mensaje
a la base de datos, junto con el nick del usuario, y regresa de inmediato. La
actualización se delega al primer método que actualiza los mensajes de todos los
usuarios.
*/

function procesarChat($arrConf, $pDBConf, $pConf, $smarty)
{
    $module_name = 'conferenceroom_list';
    include_once "modules/$module_name/configs/default.conf.php";
    include_once "modules/$module_name/libs/paloSantoCreateConference.class.php";
    include_once "modules/$module_name/libs/paloSantoListConference.class.php";
    include_once "modules/$module_name/libs/paloSantoConferenceChat.class.php";

    global $_copy_module_name;
    $GLOBALS['module_dsn'] = $arrConf['dsn_conn_database'];
    $_copy_module_name = $module_name;
    $xAjax = getXajax();
    $xAjax->processRequests();
    $smarty->assign("SCRIPT_AJAX", $xAjax->printJavascript("libs/xajax/"));

    // Leer listado de invitados al chat
    $pListChat = new paloSantoListConference($arrConf['dsn_conn_database']);
    $listaInvitados = $pListChat->listarInvitadosConferencia($_SESSION['elastix_conference_id']);
    $arrInvitados = array();
    foreach ($listaInvitados as $tuplaInvitado) {
        $privilegios = array();
        if ($tuplaInvitado['es_creador']) $privilegios[] = _tr('creator');
        if ($tuplaInvitado['es_presentador']) $privilegios[] = _tr('presentator');
        if (count($privilegios) <= 0) $privilegios[] = _tr('guest');
        
        $sLogon = '';
        if (!$tuplaInvitado['logoneado']) 
            $sLogon = _tr('No');
        else {
            $sLogon = _tr('Yes');
            if (time() - strtotime($tuplaInvitado['fecha_ultima_actividad']) > 6 * 60) {
                $sLogon .= '&nbsp;(T)';
            }
        }
        $arrInvitados[$tuplaInvitado['id_invitado']] = array(
            'nick'  =>  $tuplaInvitado['nick'],
            'privilege' =>  join(',', $privilegios),
            'logon'     =>  $sLogon,
            
            // Los dos valores mostrados indican la ausencia de video y la no-selección
            // del video correspondiente a este usuario
            'video_available'   =>  '',
            'video_select'      =>  '',
        );
    }

    // Obtener la disponibilidad de video y la asignación desde Red5
    $red5 = new SabreAMF_Client('http://localhost:5080/elastixConferenceVideo/gateway');
    try {
        $confVideoChoices = $red5->sendRequest('getConferenceVideoChoices', array($_SESSION['elastix_conference_id']));
    } catch (Exception $e) {
    	// Si falla el llamado del método, se asume NULL
        $confVideoChoices = NULL;
    } 
    $infoVideo = prepararEstadoVideo($listaInvitados, $confVideoChoices);
    foreach ($infoVideo as $iRed5User => $iRed5Target) {
        if (!is_null($iRed5Target)) {
            $arrInvitados[$iRed5User]['video_available'] = formatoIconoVideo($iRed5User, TRUE);
            $arrInvitados[$iRed5User]['video_select'] = formatoControlVideo($iRed5User, TRUE);
        }
    }
    if (!is_null($infoVideo[$_SESSION['elastix_user_id']])) {
    	$iRed5Target = $infoVideo[$_SESSION['elastix_user_id']];
        $arrInvitados[$iRed5Target]['video_select'] = formatoControlVideo($iRed5User, FALSE);
    }

    // Asignar variables para lado cliente.
    $smarty->assign('num_participants', count($arrInvitados));
    $smarty->assign('arrInvitados', $arrInvitados);
    $smarty->assign('ESTADO_VIDEO', generarCadenaEstadoVideo($infoVideo, $_SESSION['elastix_user_id']));

    $pChat = new paloSantoConferenceChat($arrConf['dsn_conn_database']);
    if (isset($_POST['chat_message']) && trim($_POST['chat_message']) != '') {
        $pChat->agregarMensajeChat(
            $_SESSION['elastix_conference_id'],
            $_SESSION['elastix_user_id'],
            $_POST['chat_message']);
    }
    $pChat->actualizarActividad(
        $_SESSION['elastix_conference_id'],
        $_SESSION['elastix_user_id']);
    $listaMensajes = $pChat->leerLogChat($_SESSION['elastix_conference_id']);

    if (!is_array($listaMensajes)) {
        $smarty->assign('CHAT_HASTA_AHORA', '<font color="#ff0000">(internal)'.$pChat->errMsg.'</font>');
    } else {
        $idUltimoMensaje = -1;
        $sTextoDIV = '';
        foreach ($listaMensajes as $infoMensaje) {
            $sTextoDIV .= formatoMensajeChat($infoMensaje)."<br/>\n";
            $idUltimoMensaje = $infoMensaje['id_secuencia'];
        }
        $smarty->assign('CHAT_HASTA_AHORA', $sTextoDIV);
        $smarty->assign('SEQ_CHAT', $idUltimoMensaje);
    }
    $smarty->assign('ELASTIX_HOSTNAME', $_SERVER['HTTP_HOST']);
    $smarty->assign('ELASTIX_CONFERENCE_ID', $_SESSION['elastix_conference_id']);
    $smarty->assign('ELASTIX_USER_ID', $_SESSION['elastix_user_id']);
    return $smarty->fetch("_common/conferencechat.tpl");
}

/* Preparar el arreglo asociativo que codifica qué usuarios tienen video, así
 * como cuál video está viendo el usuario actual. La clave del arreglo indica
 * un usuario, el valor es NULL si el usuario no transmite video, o el ID del
 * video que está viendo. */
function prepararEstadoVideo($listaInvitados, $confVideoChoices)
{
	$infoVideo = array();
    if (is_array($confVideoChoices))
    foreach ($confVideoChoices as $sRed5User => $sRed5Target) {
		$regs = NULL;
        if (preg_match('/^videoconf_\d+_(\d+)$/', $sRed5User, $regs)) {
        	$iKey = $regs[1];
            if (preg_match('/^videoconf_\d+_(\d+)$/', $sRed5Target, $regs)) {
                $iTarget = $regs[1];                
                $infoVideo[$iKey] = $iTarget;
            }
        }
	}
    foreach ($listaInvitados as $tuplaInvitado) {
    	if (!isset($infoVideo[$tuplaInvitado['id_invitado']]))
            $infoVideo[$tuplaInvitado['id_invitado']] = NULL;
    }
    ksort($infoVideo);
    return $infoVideo;
}

/* Preparar la cadena que codifica el estado de video, para el usuario $iUserId */
function generarCadenaEstadoVideo($infoVideo, $iUserId)
{
	$temp = array();
    $iMiVista = $infoVideo[$iUserId];
    foreach ($infoVideo as $iUser => $iTarget) {
		if (is_null($iTarget)) {
			array_push($temp, "$iUser");
		} else {
			array_push($temp, $iUser.(($iMiVista == $iUser) ? 'S' : 'V'));
		}
	}
    return join(':', $temp);
}

function desempacarCadenaEstadoVideo($listaInvitados, $sCadenaEstado)
{
	// Acumular IDs válidos
    $estado = array();
    foreach ($listaInvitados as $tuplaInvitado) {
    	$estado[$tuplaInvitado['id_invitado']] = NULL;
    }
    foreach (explode(':', $sCadenaEstado) as $s) {
    	$regs = NULL;
        if (preg_match('/^(\d+)(.)?$/', $s, $regs)) {
        	$e = NULL;
            if (isset($regs[2])) $e = $regs[2];
            $estado[$regs[1]] = $e;
        }
    }
    ksort($estado);
    return $estado;
}

/**
 * Procedimiento registrado para AJAX. Al recibir el mensaje, se inserta en el
 * log de mensajes 
 */
function confChat_postMessage($sMensaje)
{
    $module_name = 'conferenceroom_list';
    include_once "modules/$module_name/libs/paloSantoConferenceChat.class.php";

    $pChat = new paloSantoConferenceChat($GLOBALS['module_dsn']);

    $bExito = $pChat->agregarMensajeChat($_SESSION['elastix_conference_id'], $_SESSION['elastix_user_id'], $sMensaje);
    $respuesta = new xajaxResponse();
    if (!$bExito) {
        $respuesta->addAlert("(internal) agregarMensajeChat() failed - ".$pChat->errMsg);
    }
    return $respuesta;
}

/**
 * Procedimiento registrado por AJAX. Esta función verifica cada 1 segundos si
 * hay nuevos mensajes para el chat, y regresa luego de 2 minutos, o al encontrar
 * el nuevo mensaje.
 */
function confChat_queryMessages($idSeqMsg, $sEstadoVideo_anterior)
{
    $module_name = 'conferenceroom_list';
    include_once "modules/$module_name/libs/paloSantoConferenceChat.class.php";
    include_once "modules/$module_name/libs/paloSantoListConference.class.php";

    $iTimeoutPoll = 2 * 60;

    // Problemas con MSIE al haber más de un AJAX con respuesta larga
    if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE ') !== false) {
        $iTimeoutPoll = 2;
    }

    /* El comportamiento por omisión de la sesión por PHP bloquea el session_start()
       mientras otro cliente use la misma sesión. Esto impide que se ejecuten otras
       operaciones mientras el método AJAX todavía no responde. Para prevenir esto, 
       se hace una copia de los datos requeridos de la sesión, y luego se libera 
       la sesión.
     */
    $local_elastix_conference_id = $_SESSION['elastix_conference_id'];
    $local_elastix_user_id = $_SESSION['elastix_user_id'];
    session_commit();
    
    set_time_limit(0);
    $bContinuar = TRUE;
    $iTimestampInicio = time();

    $pChat = new paloSantoConferenceChat($GLOBALS['module_dsn']);
    $respuesta = new xajaxResponse();

    $pChat->actualizarActividad($_SESSION['elastix_conference_id'], $_SESSION['elastix_user_id']);

    // Obtener la disponibilidad de video y la asignación desde Red5
    $red5 = new SabreAMF_Client('http://localhost:5080/elastixConferenceVideo/gateway');
    $pListChat = new paloSantoListConference($GLOBALS['module_dsn']);
    $listaInvitados = $pListChat->listarInvitadosConferencia($local_elastix_conference_id);

    while ($bContinuar && time() - $iTimestampInicio <  $iTimeoutPoll) {
        // Estado de actualización del chat
        $listaMensajes = $pChat->leerLogChat($local_elastix_conference_id, $idSeqMsg);
        if (!is_array($listaMensajes)) {
            $respuesta->addAlert("leerLogChat() failed - ".$pChat->errMsg);
            $bContinuar = FALSE;
            return $respuesta;
        } else {
            if (count($listaMensajes) > 0) {
                // Hay algún mensaje nuevo en el chat.
                $sTextoDIV = '';
                $idUltimoMensaje = NULL;
                foreach ($listaMensajes as $infoMensaje) {
                    $sTextoDIV .= formatoMensajeChat($infoMensaje)."<br/>";
                    $idUltimoMensaje = $infoMensaje['id_secuencia'];
                }
                $respuesta->addAppend('div_chat', 'innerHTML', $sTextoDIV);
                $respuesta->addAssign('seq_chat', 'value', $idUltimoMensaje);
                $respuesta->addScript('c = document.getElementById("div_chat"); if (c.clientHeight < c.scrollHeight) { c.scrollTop = c.scrollHeight - c.clientHeight; }');
                $bContinuar = FALSE;
            }
        }
        
        // Estado de actualización del video
        try {
            $confVideoChoices = $red5->sendRequest('getConferenceVideoChoices', array($local_elastix_conference_id));
        } catch (Exception $e) {
            // Si falla el llamado del método, se asume NULL
            $confVideoChoices = NULL;
        } 
        $infoVideo = prepararEstadoVideo($listaInvitados, $confVideoChoices);
        $sEstadoVideo_nuevo = generarCadenaEstadoVideo($infoVideo, $local_elastix_user_id);
        if ($sEstadoVideo_anterior != $sEstadoVideo_nuevo) {
        	$bContinuar = FALSE;
            
            $vAnterior = desempacarCadenaEstadoVideo($listaInvitados, $sEstadoVideo_anterior);
            $vNuevo  = desempacarCadenaEstadoVideo($listaInvitados, $sEstadoVideo_nuevo);
            foreach ($vNuevo as $idUsuario => $nuevoEstado) {
            	if (is_null($nuevoEstado)) {
            		// Estado de usuario sin video por transmitir
                    $respuesta->addAssign('guest_video_available_'.$idUsuario, 'innerHTML', formatoIconoVideo($idUsuario, FALSE));
                    $respuesta->addAssign('guest_video_select_'.$idUsuario, 'innerHTML', '');
            	} elseif ($nuevoEstado == 'V') {
                    // Usuario tiene video, usuario local no lo está viendo
                    $respuesta->addAssign('guest_video_available_'.$idUsuario, 'innerHTML', formatoIconoVideo($idUsuario, TRUE));
                    $respuesta->addAssign('guest_video_select_'.$idUsuario, 'innerHTML', formatoControlVideo($idUsuario, TRUE));
            	} else {
            		// Usuario tiene video, usuario local lo está viendo
                    $respuesta->addAssign('guest_video_available_'.$idUsuario, 'innerHTML', formatoIconoVideo($idUsuario, TRUE));
                    $respuesta->addAssign('guest_video_select_'.$idUsuario, 'innerHTML', formatoControlVideo($idUsuario, FALSE));
            	}
            }
            $respuesta->addAssign('estado_video', 'value', $sEstadoVideo_nuevo);
        }

        if ($bContinuar) {
            time_nanosleep(0, 500000000);
        }
    }

    // Leer listado de invitados al chat
    $listaInvitados = $pListChat->listarInvitadosConferencia($local_elastix_conference_id);
    if (is_array($listaInvitados)) foreach ($listaInvitados as $tuplaInvitado) {
        $bTimeout = FALSE;
        $privilegios = array();
        if ($tuplaInvitado['es_creador']) $privilegios[] = _tr('creator');
        if ($tuplaInvitado['es_presentador']) $privilegios[] = _tr('presentator');
        if (count($privilegios) <= 0) $privilegios[] = _tr('guest');
        
        $sLogon = '';
        if (!$tuplaInvitado['logoneado']) 
            $sLogon = _tr('No');
        else {
            $sLogon = _tr('Yes');
            if (time() - strtotime($tuplaInvitado['fecha_ultima_actividad']) > 6 * 60) {
                $bTimeout = TRUE;
            }
        }
        $respuesta->addAssign('guest_privilege_'.$tuplaInvitado['id_invitado'], 'innerHTML', htmlentities(join(',', $privilegios), ENT_COMPAT, "UTF-8"));
        $respuesta->addAssign('guest_logon_'.$tuplaInvitado['id_invitado'], 'innerHTML', htmlentities( $sLogon, ENT_COMPAT, "UTF-8").($bTimeout ? '&nbsp;(T)' : ''));
    }

    $respuesta->addScript("setTimeout(\"queryChatMessages()\", 1);");


    return $respuesta;
}

/**
 * Procedimiento registrado por AJAX. Esta función implementa la operación de 
 * cambiar el video que se muestra al usuario a través de una llamada a la 
 * función setConferenceVideoChoice que reside en la aplicación Red5. 
 */
function confChat_changeVideo($iTargetVideo)
{
    $respuesta = new xajaxResponse();
    if (!preg_match('/^\d+$/', $iTargetVideo)) return $respuesta;
	$red5 = new SabreAMF_Client('http://localhost:5080/elastixConferenceVideo/gateway');
    try {
        $red5->sendRequest('setConferenceVideoChoice', array($_SESSION['elastix_conference_id'], $_SESSION['elastix_user_id'], $iTargetVideo));
    } catch (Exception $e) {
    } 
    return $respuesta;
}

function formatoControlVideo($iTargetId, $bPuedeSeleccionar)
{
	return $bPuedeSeleccionar 
        ? "<a href=\"javascript:\" onClick=\"xajax_confChat_changeVideo($iTargetId)\">[s]</a>"
        : 'S';
}

function formatoIconoVideo($iTargetId, $bPresente)
{
	return $bPresente ? "<img src=\"themes/conference/images/video.png\" alt=\"Video available\" />" : '';
}

function formatoMensajeChat($infoMensaje)
{
    $iFechaMensaje = strtotime($infoMensaje['fecha']);
    if (date('Y-m-d', $iFechaMensaje) == date('Y-m-d'))
        $sFormatoFecha = date('H:i:s', $iFechaMensaje);
    else $sFormatoFecha = $infoMensaje['fecha'];
    if (!is_null($infoMensaje['nick'])) {
        return sprintf('(%s) %s: %s', $sFormatoFecha, $infoMensaje['nick'], htmlentities($infoMensaje['mensaje'], ENT_COMPAT, "UTF-8"));
    } else {
        /* Si el nick es NULL, el mensaje es un mensaje del sistema que indica
           que ha ocurrido un evento especial 
         */
        $infoEvento = explode(' ', trim($infoMensaje['mensaje']));
        if (count($infoEvento) > 0) {
            switch ($infoEvento['0']) {
            case 'login':
                array_shift($infoEvento);
                return sprintf('<b>(%s) [%s]</b>', $sFormatoFecha, sprintf('User %s logged in', implode(' ', $infoEvento)));
                break;
            case 'logout':
                array_shift($infoEvento);
                return sprintf('<b>(%s) [%s]</b>', $sFormatoFecha, sprintf('User %s logged out', implode(' ', $infoEvento)));
                break;
            case 'handoff':
                return sprintf('<b>(%s) [%s]</b>', $sFormatoFecha, sprintf('User %s hands off presentation to user %s', $infoEvento[1], $infoEvento[2]));
                break;
            case 'recover':
                return sprintf('<b>(%s) [%s]</b>', $sFormatoFecha, sprintf('User %s takes back presentation', $infoEvento[1]));
                break;
            case 'uploadstart':
                return sprintf('<b>(%s) [%s]</b>', $sFormatoFecha, sprintf('User %s is uploading a document...', $infoEvento[1]));
                break;
            case 'uploadend':
                return sprintf('<b>(%s) [%s]</b>', $sFormatoFecha, sprintf('User %s finished uploading a document.', $infoEvento[1]));
                break;
            case 'uploadfail':
                return sprintf('<b>(%s) [%s]</b>', $sFormatoFecha, sprintf('User %s could not finish uploading a document.', $infoEvento[1]));
                break;
            default:
                return sprintf('<b>(%s) [UNPARSED: %s]</b>', $sFormatoFecha, $infoMensaje['mensaje']);
                break;
            }
        } else {
            return sprintf('(%s) %s', $sFormatoFecha, '<b>Invalid empty event</b>');
        }
    }
}
?>
