<?php
  /* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 1.6-5                                               |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: index.php,v 1.1 2009-06-29 08:06:01 Alex Villacís Lasso a_villacis@palosanto.com Exp $ */
//include elastix framework
include_once "libs/paloSantoGrid.class.php";
include_once "libs/paloSantoForm.class.php";

function _moduleContent(&$smarty, $module_name)
{
    //include module files
    include_once "modules/$module_name/configs/default.conf.php";
//    include_once "modules/$module_name/libs/paloSantoDocumentViewer.class.php";
    include_once "modules/$module_name/libs/paloSantoDocumentRepository.class.php";

    //include file language agree to elastix configuration
    //if file language not exists, then include language by default (en)
    $lang=get_language();
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    $lang_file="modules/$module_name/lang/$lang.lang";
    include_once "modules/$module_name/lang/en.lang";
    if (file_exists("$base_dir/$lang_file")) {
        $arrLangEN = $arrLangModule;
        include_once "$lang_file";
        $arrLangModule = array_merge($arrLangEN, $arrLangModule);
    }

    // TODO: traducir
    if (!isset($_SESSION['elastix_conference_id'])) return "(internal) No conference has been selected!";

    //global variables
    global $arrConf;
    global $arrConfModule;
    global $arrLang;
    global $arrLangModule;
    $arrConf = array_merge($arrConf,$arrConfModule);
    $arrLang = array_merge($arrLang,$arrLangModule);

    $smarty->assign('MODULE_NAME', $module_name);
    $smarty->assign('title', $arrLang['Document Repository for Conference']);

    //folder path for custom templates
    $templates_dir=(isset($arrConf['templates_dir']))?$arrConf['templates_dir']:'themes';
    $local_templates_dir="$base_dir/modules/$module_name/".$templates_dir.'/'.$arrConf['theme'];

    //conexion resource
    $pDB = new paloDB($arrConf['dsn_conn_database']);

    $content = '';
    if (isset($_POST['upload'])) 
         $sAction = 'upload_doc';
    else $sAction = getParameter('action');
    switch ($sAction)
    {
    case 'download_doc':
        $content = descargarDocumento($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang);
        break;
    case 'upload_doc':
        $content = cargarNuevoDocumento($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang);
    default:
        // Este caso maneja la visualización del documento convertido en sí
        $content .= visualizarDocumento($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang);
    }

    return $content;
}

function cargarNuevoDocumento($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf, $arrLang)
{
    $sContenido = '';

    if ($_FILES['upload_file']['error'] != 0) {
        $smarty->assign("mb_title", $arrLang['Problem while uploading file']);
        switch ($_FILES['upload_file']['error']) {
        case  UPLOAD_ERR_INI_SIZE:
            $smarty->assign("mb_message", $arrLang['Uploaded file is larger than allowed by PHP configuration.']);
            break;
        case UPLOAD_ERR_INI_SIZE:
            $smarty->assign("mb_message", $arrLang['Uploaded file is larger than allowed by PHP configuration.']);
            break;
        case UPLOAD_ERR_FORM_SIZE:
            $smarty->assign("mb_message", $arrLang['Uploaded file is larger than allowed by MAX_FILE_SIZE.']);
            break;
        case UPLOAD_ERR_PARTIAL:
            $smarty->assign("mb_message", $arrLang['File was only partially uploaded.']);
            break;
        case UPLOAD_ERR_NO_FILE:
            $smarty->assign("mb_message", $arrLang['No file was specified for upload.']);
            break;
        case UPLOAD_ERR_NO_TMP_DIR:
            $smarty->assign("mb_message", $arrLang['No PHP temporary folder configured. Check PHP configuration.']);
            break;
        case UPLOAD_ERR_CANT_WRITE:
            $smarty->assign("mb_message", $arrLang['Unable to write temporary (not enough disk space, or access denied).']);
            break;
        case  8:    //  UPLOAD_ERR_EXTENSION  
            $smarty->assign("mb_message", 'Uploaded file blocked by forbidden file extension.');
            break;
        }
    } else {
        $idNuevoDoc = NULL;
        $pDocRepo = new paloSantoDocumentRepository($pDB, $_SESSION['elastix_conference_id'], $arrConf['docimgs_dir']);
        if ($pDocRepo->errMsg != '') {
            $smarty->assign("mb_title", $arrLang['Failed to convert document']);
            $smarty->assign("mb_message", $arrLang['On startup'].' - '.$pDocRepo->errMsg);
        } else {
            $bExito = $pDocRepo->registerUploadDoc(
                $_FILES['upload_file'], 
                $_SESSION['elastix_user_id'], 
                $idNuevoDoc);
            if (!$bExito) {
                $smarty->assign("mb_title", $arrLang['Failed to convert document']);
                $smarty->assign("mb_message", $pDocRepo->errMsg);
            } else {
                $smarty->assign("mb_title", $arrLang['Document uploaded successfully']);
                $smarty->assign("mb_message", $arrLang['Document uploaded successfully']);
            }
        }
    }
    return $sContenido;
}

function visualizarDocumento($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf, $arrLang)
{
    $smarty->assign("IMG", "images/list.png");
    $smarty->assign('MODULE_NAME', $module_name);
    $pDocRepo = new paloSantoDocumentRepository($pDB, $_SESSION['elastix_conference_id'], $arrConf['docimgs_dir']);
    if (isset($_POST['remove_document']) && isset($_POST['id_documento'])) {
        // Se procede a remover el documento
        $bExito = $pDocRepo->deleteUploadDoc($_POST['id_documento']);
        if (!$bExito) {
            $smarty->assign("mb_title", $arrLang['Cannot remove document']);
            $smarty->assign("mb_message", $pDocumentViewer->errMsg);
        } else {
            $smarty->assign("mb_title", $arrLang['Document removed']);
            $smarty->assign("mb_message", $arrLang['Document removed correctly']);
        }
    }

    // Listar los documentos existentes
    $listaDocs = $pDocRepo->getDocumentList();
    $arrData = array();
    if (!is_array($listaDocs)) {
        $smarty->assign("mb_title", $arrLang['Cannot list documents']);
        $smarty->assign("mb_message", $pDocRepo->errMsg);
    } else {
        foreach ($listaDocs as $tuplaDoc) {
            $arrData[] = array(
                "<input type=\"radio\" name=\"id_documento\" value=\"$tuplaDoc[id_documento]\"/>",
                htmlentities($tuplaDoc['nombre_original'], ENT_COMPAT, "UTF-8"),
                htmlentities($tuplaDoc['nick'], ENT_COMPAT, "UTF-8"),
                $tuplaDoc['fecha_upload'],
                "<a href=\"?menu=$module_name&amp;action=download_doc&amp;rawmode=yes&amp;id_documento=$tuplaDoc[id_documento]\">[".'Download'.']</a>',
            );
        }
    }

    $oGrid = new paloSantoGrid($smarty);
    $arrGrid = array("title"    => $arrLang['Document Repository for Conference'],
                     "icon"     => "images/list.png",
                     "width"    => "98%",
                     'start'    => 0,
                     'end'      => count($arrData),
                     'total'    => count($arrData),
                     "columns"  => array(
                                         0 => array("name"      => '<input type="submit" class="button" name="remove_document" value="'.$arrLang['Remove'].'"/>',
                                                    "property1" => ""),
                                         1 => array("name"      => $arrLang['Document'],
                                                    "property1" => ""),
                                         2 => array("name"      => $arrLang['Upload user'],
                                                    "property1" => ""),
                                         3 => array("name"      => $arrLang['Upload time'],
                                                    "property1" => ""),
                                         4 => array("name"      => $arrLang['Options'],
                                                    "property1" => ""),
                                        )
                    );
    $smarty->assign(array(
        'no_doc_selected'   =>  $arrLang['No document selected for viewing'],
        'label_document'    =>  $arrLang['Document'],
        'label_page'        =>  $arrLang['Page'],
        'label_upload_new_file' => $arrLang['Upload new file'],
        'label_upload'      =>  $arrLang['Upload'],
    ));
    $oGrid->showFilter($smarty->fetch("$local_templates_dir/form.tpl"));
    $htmlGrid = $oGrid->fetchGrid($arrGrid, $arrData, $arrLang);

    $sContenido = "<form  method='post' style='margin-bottom:0;' action='?menu=$module_name' enctype='multipart/form-data'>" .
        $htmlGrid."</form>";
    return $sContenido;
}

function descargarDocumento($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf, $arrLang)
{
    $sContenido = "";
    if (isset($_GET['id_documento'])) {
        $idDocumento = $_GET['id_documento'];

        $pDocRepo = new paloSantoDocumentRepository($pDB, $_SESSION['elastix_conference_id'], $arrConf['docimgs_dir']);
        $sContenido = $pDocRepo->readDocumentContent($idDocumento);
    }
    return $sContenido;
}

?>
