<?php
  /* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 1.6-5                                               |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: index.php,v 1.1 2009-06-29 08:06:39 Alex Villacís Lasso a_villacis@palosanto.com Exp $ */

function mostrarListaConferencias($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang)
{
    // Verificar si se debe remover la conferencia
    if (isset($_POST['remove_conference']) && isset($_POST['id_conf_remove'])) {
        include_once "modules/$module_name/libs/paloSantoCreateConference.class.php";
        $pCreateConference = new paloSantoCreateConference($pDB);

        $bExito = $pCreateConference->deleteConference($_POST['id_conf_remove']);
        if ($bExito) {
            $smarty->assign("mb_title", $arrLang['Conference deleted']);
            $smarty->assign("mb_message", $arrLang['Conference successfully deleted']);
        } else {
            $smarty->assign("mb_title", $arrLang['Conference delete error']);
            $smarty->assign("mb_message", $pCreateConference->errMsg);
        }
    }

    $pDB2 = new paloDB($arrConf['elastix_dsn']['acl']);
    $pACL = new paloACL($pDB2);
    $isUserAdministratorGroup = $pACL->isUserAdministratorGroup($_SESSION['elastix_user']);

    $pListConf = new paloSantoListConference($pDB);
    $listNum   = $pListConf->getNumListarConferencias($isUserAdministratorGroup);

    $oGrid  = new paloSantoGrid($smarty);
    $total  = $listNum;
    $oGrid->setTitle(_tr("Conferences"));
    $limit  = 20;
    $oGrid->setLimit($limit);
    $oGrid->setTotal($total);
    $offset = $oGrid->calculateOffset();
    $listaConf = $pListConf->listarConferencias($isUserAdministratorGroup, FALSE, $limit, $offset);

    $url = array(
        'menu'          =>  $module_name,
    );
    $oGrid->setURL($url);
    $listaEstados = array(
        'pendiente' =>  $arrLang['Yet to start'],
        'activa'    =>  $arrLang['Currently active'],
        'expirada'  =>  $arrLang['Finished'],
    );
    // Organizar los datos en la tabla
    $arrData = array();
    foreach ($listaConf as $tuplaConf) {

        // Verificar si la conferencia está expirada, pendiente, o activa
        $sEstadoConf = NULL;
        $sFechaActual = date('Y-m-d H:i:s');
        if ($tuplaConf['fecha_inicio'] > $sFechaActual)
            $sEstadoConf = 'pendiente';
        elseif ($tuplaConf['fecha_final'] > $sFechaActual)
            $sEstadoConf = 'activa';
        else $sEstadoConf = 'expirada';

        $arrData[] = array(
            '<input type="radio" name="id_conf_remove" value="'.$tuplaConf['id_conferencia'].'" />',
            htmlentities($tuplaConf['nombre'], ENT_COMPAT, "UTF-8"),
            htmlentities($tuplaConf['tema'], ENT_COMPAT, "UTF-8"),
            $tuplaConf['fecha_inicio'],
            $tuplaConf['fecha_final'],
            $listaEstados[$sEstadoConf],
            $tuplaConf['num_invitados'],
            $tuplaConf['num_documentos'],
            "<a href=\"?menu=$module_name&amp;action=list_guests&amp;id_conference=$tuplaConf[id_conferencia]\">[{$arrLang['List guests']}]</a>&nbsp;".
            "<a href=\"?menu=$module_name&amp;action=list_chatlog&amp;id_conference=$tuplaConf[id_conferencia]\">[{$arrLang['Chatlog']}]</a>",
        );
    }

    $arrColumns = array(_tr(""), _tr("Name"), _tr("Topic"), _tr("Start"), _tr("End"),_tr("Status"),_tr("# Guests"),_tr("# Docs"),_tr("Options"));
    $oGrid->setColumns($arrColumns);
    $oGrid->setData($arrData);

    $oGrid->showFilter('<input type="submit" name="new_open" class="button" value="'.$arrLang['Create new conference'].'" />');
    $content = $oGrid->fetchGrid();

    return $content;
}

function mostrarListaInvitados($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang)
{
    include_once "modules/conferenceroom_list/libs/paloSantoCreateConference.class.php";
    include_once "modules/conferenceroom_list/libs/paloSantoListConference.class.php";
    $pCreateConference = new paloSantoCreateConference($pDB);

    $id_conference = getParameter('id_conference');
    if (is_null($id_conference) || !ereg('^[[:digit:]]+$', $id_conference)) {
        Header("Location: ?menu=$module_name");
    }

    $pDB2 = new paloDB($arrConf['elastix_dsn']['acl']);
    $pACL = new paloACL($pDB2);
    $pListConf = new paloSantoListConference($pDB);
    if(!$pACL->isUserAdministratorGroup($_SESSION['elastix_user'])){
        $flag=0;
        $idsforUser = $pListConf->listarid_conferenceforUser($_SESSION['elastix_user']);
        if(is_array($idsforUser))
            foreach($idsforUser as $key => $value)
                if($value['id_conferencia'] == $id_conference)
                    $flag=1;
        if($flag==0){
            $smarty->assign("mb_title",_tr("ERROR"));
            $smarty->assign("mb_message",_tr("You are not authorized to enter to that conference"));
            return mostrarListaConferencias($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang);
        }
    }

    $infoConf = $pListConf->leerConferencia($id_conference);

    if (!is_array($infoConf)) {
        Header("Location: ?menu=$module_name");
    }

    $smarty->assign($infoConf);

    // Verificar si la conferencia está expirada, pendiente, o activa
    $sEstadoConf = NULL;
    $sFechaActual = date('Y-m-d H:i:s');
    if ($infoConf['fecha_inicio'] > $sFechaActual)
        $sEstadoConf = 'pendiente';
    elseif ($infoConf['fecha_final'] > $sFechaActual)
        $sEstadoConf = 'activa';
    else $sEstadoConf = 'expirada';
    
    if ($sEstadoConf != 'expirada') {
        $smarty->assign('conferencia_activa', TRUE);
    }
    
    // Etiquetar apropiadamente el estado de la conferencia
    $listaEstados = array(
        'pendiente' =>  $arrLang['Yet to start'],
        'activa'    =>  $arrLang['Currently active'],
        'expirada'  =>  $arrLang['Finished'],
    );
    $smarty->assign('MODULE_NAME', $module_name);
    $smarty->assign('status_conferencia', $listaEstados[$sEstadoConf]);

    // Verificar si se debe agregar un nuevo invitado a la conferencia
    if (isset($_POST['add_invitado'])) {
        $idInvitado = NULL;
        $bExito = $pCreateConference->agregarInvitadoConferencia(
            $id_conference, 
            $_POST['email_invitado'], 
            NULL, 
            $_POST['nombre_invitado'], 
            $idInvitado);
        if (!$bExito) {
            $smarty->assign("mb_title", $arrLang['Conference update error']);
            $smarty->assign("mb_message", $pCreateConference->errMsg);
        } else {
            $bExito = $pCreateConference->enviarCorreoInvitacion($id_conference, $idInvitado);
            if ($bExito) {
                $smarty->assign("mb_title", $arrLang['Conference update OK']);
                $smarty->assign("mb_message", $arrLang['New guest has been added and invited.']);
            } else {
                $smarty->assign("mb_title", $arrLang['Conference update error']);
                $smarty->assign("mb_message", $arrLang['Guest added but could not be invited'].' - '.$pCreateConference->errMsg);
            }
        }
    }

    // Verificar si se debe de remover un invitado de la conferencia
    if (isset($_POST['remove_guest']) && isset($_POST['id_guest_remove'])) {
        $infoInvitado = $pCreateConference->leerInvitadoConferencia($id_conference, $_POST['id_guest_remove']);
        if (is_null($infoInvitado)) {
            $smarty->assign("mb_title", $arrLang['Conference update error']);
            $smarty->assign("mb_message", $arrLang['Unable to read guest properties'].' - '.$pCreateConference->errMsg);
        } elseif ($infoInvitado['es_creador']) {
            $smarty->assign("mb_title", $arrLang['Conference update error']);
            $smarty->assign("mb_message", 'Conference host may not be removed.');
        } elseif ($infoInvitado['es_presentador']) {
            $smarty->assign("mb_title", $arrLang['Conference update error']);
            $smarty->assign("mb_message", $arrLang['Conference presentator may not be removed.']);
        } else {
            $bExito = $pCreateConference->removerInvitadoConferencia($id_conference, $_POST['id_guest_remove']);
            if ($bExito) {
                $smarty->assign("mb_title", $arrLang['Conference update OK']);
                $smarty->assign("mb_message", $arrLang['Guest successfully removed from conference.']);
            } else {
                $smarty->assign("mb_title", $arrLang['Conference update error']);
                $smarty->assign("mb_message", $arrLang['Unable to remove guest'].' - '.$pCreateConference->errMsg);
            }
        }
    }

    // Verificar si se debe de volver a invitar a un invitado en particular
    if (isset($_POST['reinvite_guest']) && isset($_POST['id_guest_remove'])) {
        $bExito = $pCreateConference->enviarCorreoInvitacion($id_conference, $_POST['id_guest_remove']);
        if ($bExito) {
            $smarty->assign('mb_title', $arrLang['Re-sending Conference Invitation']);
            $smarty->assign('mb_message', $arrLang['Conference invitation resent to selected guest']);
        } else {
            $smarty->assign('mb_title', $arrLang['Failed to re-send invitation']);
            $smarty->assign('mb_message', $arrLang['Unable to re-send invitation'].' - '.$pCreateConference->errMsg);
        }        
    }    

    // Verificar si se debe volver a invitar a todos los invitados
    if (isset($_POST['reissue_invitation'])) {
        $pCreateConference->enviarCorreoInvitacion($id_conference);
        $smarty->assign('mb_title', $arrLang['Re-sending Conference Invitation']);
        $smarty->assign('mb_message', $arrLang['Conference invitation resent to all registered guests']);
    }

    $listaGuest = $pListConf->listarInvitadosConferencia($id_conference);

    // Organizar los datos en la tabla
    $arrData = array();
    foreach ($listaGuest as $tuplaGuest) {
        // Construir los descriptores de privilegios
        $priv = array();
        if ($tuplaGuest['es_creador']) $priv[] = $arrLang['creator'];
        if ($tuplaGuest['es_presentador']) $priv[] = $arrLang['presentator'];
        if (count($priv) == 0) $priv[] = $arrLang['guest'];

        $arrData[] = array(
            ($sEstadoConf != 'expirada') ? '<input type="radio" name="id_guest_remove" value="'.$tuplaGuest['id_invitado'].'" />' : '',
            htmlentities($tuplaGuest['nick'], ENT_COMPAT, "UTF-8"),
            "<a href=\"mailto:$tuplaGuest[email]\">".htmlentities($tuplaGuest['email'], ENT_COMPAT, "UTF-8").'</a>',
            join(', ', $priv),
//            ''
        );
    }

    // Para agregar un nuevo invitado a la conferencia
    if ($sEstadoConf != 'expirada') {
        $arrData[] = array(
            '<input type="submit" class="button" name="add_invitado" value="'.$arrLang['Add New Guest'].'" />',
            '<input type="text" class="input" name="nombre_invitado" size="32" maxlength="128"/>',
            '<input type="text" class="input" name="email_invitado" size="32" maxlength="128"/>', 
            ''
            );
    }

    $oGrid = new paloSantoGrid($smarty);
    $oGrid->pagingShow(false);
    $arrGrid = array("title"    => $arrLang['Guests in conference'].': '.htmlentities($infoConf['nombre'], ENT_COMPAT, "UTF-8").' - '.htmlentities($infoConf['tema'], ENT_COMPAT, "UTF-8"),
                     "icon"     => "images/user.png",
                     "width"    => "100%",
                     'start'    => 0,
                     'end'      => count($arrData),
                     'total'    => count($arrData),
                     "columns"  => array(
                                         0 => array("name"      => ($sEstadoConf != 'expirada') 
                                         ? '<input type="submit" class="button" name="remove_guest" value="'.$arrLang['Remove'].'" />'.
                                           '<input type="submit" class="button" name="reinvite_guest" value="'.$arrLang['Re-invite'].'" />'
                                         : '',
                                                    "property1" => ""),
                                         1 => array("name"      => $arrLang['Name/Nick'],
                                                    "property1" => ""),
                                         2 => array("name"      => $arrLang['E-Mail'],
                                                    "property1" => ""),
                                         3 => array("name"      => $arrLang['Privileges'],
                                                    "property1" => ""),
/*
                                         4 => array("name"      => 'Options',
                                                    "property1" => ""),*/
                                        )
                    );
    $smarty->assign(array(
        'LABEL_CONFERENCE_INFORMATION'      =>  $arrLang['Conference Information'],
        'LABEL_NAME'                        =>  $arrLang['Name'],
        'LABEL_TOPIC'                       =>  $arrLang['Topic'],
        'LABEL_START_DATE'                  =>  $arrLang['Start Date'],
        'LABEL_END_DATE'                    =>  $arrLang['End Date'],
        'LABEL_CURRENT_STATUS'              =>  $arrLang['Current Status'],
        'LABEL_REISSUE_INVITATION'          =>  $arrLang['Re-send Conference Invitation to All'],
        'LABEL_BACK'                        =>  $arrLang['Back'],
    ));
    $htmlForm = $smarty->fetch("$local_templates_dir/form.tpl");
    $htmlGrid = $oGrid->fetchGrid($arrGrid, $arrData, $arrLang);
    $content = "<form  method='POST' style='margin-bottom:0;' action='?menu=$module_name&amp;action=list_guests&amp;id_conference=$id_conference'>" . $htmlForm.$htmlGrid."</form>";

    return $content;
}

function mostrarChatlog($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang)
{
    include_once "modules/conferenceroom_list/libs/paloSantoConferenceChat.class.php";
    include_once "modules/conferenceroom_list/libs/paloSantoListConference.class.php";
    $pConfChat = new PaloSantoConferenceChat($pDB);

    $id_conference = getParameter('id_conference');
    if (is_null($id_conference) || !ereg('^[[:digit:]]+$', $id_conference)) {
        Header("Location: ?menu=$module_name");
    }

    $pDB2 = new paloDB($arrConf['elastix_dsn']['acl']);
    $pACL = new paloACL($pDB2);
    $pListConf = new paloSantoListConference($pDB);
    if(!$pACL->isUserAdministratorGroup($_SESSION['elastix_user'])){
        $flag=0;
        $idsforUser = $pListConf->listarid_conferenceforUser($_SESSION['elastix_user']);
        if(is_array($idsforUser))
            foreach($idsforUser as $key => $value)
                if($value['id_conferencia'] == $id_conference)
                    $flag=1;
        if($flag==0){
            $smarty->assign("mb_title",_tr("ERROR"));
            $smarty->assign("mb_message",_tr("You are not authorized to enter to that conference"));
            return mostrarListaConferencias($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang);
        }
    }

    $infoConf = $pListConf->leerConferencia($id_conference);

    if (!is_array($infoConf)) {
        Header("Location: ?menu=$module_name");
    }

    $smarty->assign($infoConf);

    // Verificar si la conferencia está expirada, pendiente, o activa
    $sEstadoConf = NULL;
    $sFechaActual = date('Y-m-d H:i:s');
    if ($infoConf['fecha_inicio'] > $sFechaActual)
        $sEstadoConf = 'pendiente';
    elseif ($infoConf['fecha_final'] > $sFechaActual)
        $sEstadoConf = 'activa';
    else $sEstadoConf = 'expirada';
    
    // Etiquetar apropiadamente el estado de la conferencia
    $listaEstados = array(
        'pendiente' =>  $arrLang['Yet to start'],
        'activa'    =>  $arrLang['Currently active'],
        'expirada'  =>  $arrLang['Finished'],
    );
    $smarty->assign('MODULE_NAME', $module_name);
    $smarty->assign('status_conferencia', $listaEstados[$sEstadoConf]);

    $logChat = $pConfChat->leerLogChat($id_conference);

    // Paginación
    $total = count($logChat);
    $limit = 20;
    $offset = 0;
    if (isset($_GET['nav']) && $_GET['nav']=="end") {
        if (($total % $limit)==0) {
            $offset = $total - $limit;
        } else {
            $offset = $total - $total % $limit; 
        }        
    }
    // Si se quiere avanzar a la sgte. pagina
    if(isset($_GET['nav']) && $_GET['nav']=="next") {
        $offset = $_GET['start'] + $limit - 1;
    }
    // Si se quiere retroceder
    if(isset($_GET['nav']) && $_GET['nav']=="previous") {
        $offset = $_GET['start'] - $limit - 1;
    }

    // Organizar los datos en la tabla
    $logChat_slice = array_slice($logChat, $offset, $limit);
    $arrData = array();
    foreach ($logChat_slice as $tuplaChat) {
        $arrData[] = array(
            $tuplaChat['fecha'],
            $tuplaChat['nick'],
            formatoMensajeChat($tuplaChat)
        );
    }
    $smarty->assign('url', construirURL(array(), array("nav", "start")));

    $oGrid = new paloSantoGrid($smarty);
    $arrGrid = array("title"    => $arrLang['Chat log of conference'].': '.htmlentities($infoConf['nombre'], ENT_COMPAT, "UTF-8").' - '.htmlentities($infoConf['tema'], ENT_COMPAT, "UTF-8"),
                     "icon"     => "images/user.png",
                     "width"    => "100%",
/*
                     'start'    => 0,
                     'end'      => count($arrData),
                     'total'    => count($arrData),
*/
                     "start"    => ($total==0) ? 0 : $offset + 1,
                     "end"      => ($offset+$limit)<=$total ? $offset+$limit : $total,
                     "total"    => $total,

                     "columns"  => array(
                                         0 => array("name"      => $arrLang['Date'],
                                                    "property1" => ""),
                                         1 => array("name"      => $arrLang['Name/Nick'],
                                                    "property1" => ""),
                                         2 => array("name"      => $arrLang['Message'],
                                                    "property1" => ""),
                                        )
                    );


    $smarty->assign(array(
        'LABEL_CONFERENCE_INFORMATION'      =>  $arrLang['Conference Information'],
        'LABEL_NAME'                        =>  $arrLang['Name'],
        'LABEL_TOPIC'                       =>  $arrLang['Topic'],
        'LABEL_START_DATE'                  =>  $arrLang['Start Date'],
        'LABEL_END_DATE'                    =>  $arrLang['End Date'],
        'LABEL_CURRENT_STATUS'              =>  $arrLang['Current Status'],
        'LABEL_REISSUE_INVITATION'          =>  $arrLang['Re-send Conference Invitation to All'],
        'LABEL_BACK'                        =>  $arrLang['Back'],
    ));
    $htmlForm = $smarty->fetch("$local_templates_dir/form.tpl");
    $htmlGrid = $oGrid->fetchGrid($arrGrid, $arrData, $arrLang);
    $content = "<form  method='POST' style='margin-bottom:0;' action='?menu=$module_name&amp;action=list_guests&amp;id_conference=$id_conference'>" . $htmlForm .$htmlGrid."</form>";

    return $content;
}

function formatoMensajeChat($infoMensaje)
{
    $iFechaMensaje = strtotime($infoMensaje['fecha']);
    if (date('Y-m-d', $iFechaMensaje) == date('Y-m-d'))
        $sFormatoFecha = date('H:i:s', $iFechaMensaje);
    else $sFormatoFecha = $infoMensaje['fecha'];
    if (!is_null($infoMensaje['nick'])) {
//        return sprintf('(%s) %s: %s', $sFormatoFecha, $infoMensaje['nick'], htmlentities($infoMensaje['mensaje'], ENT_COMPAT, "UTF-8"));
        return sprintf('%s', htmlentities($infoMensaje['mensaje'], ENT_COMPAT, "UTF-8"));
    } else {
        /* Si el nick es NULL, el mensaje es un mensaje del sistema que indica
           que ha ocurrido un evento especial 
         */
        $infoEvento = explode(' ', trim($infoMensaje['mensaje']));
        if (count($infoEvento) > 0) {
            switch ($infoEvento['0']) {
            case 'login':
                array_shift($infoEvento);
                return sprintf('<b>[%s]</b>', sprintf('User %s logged in', implode(' ', $infoEvento)));
                break;
            case 'logout':
                array_shift($infoEvento);
                return sprintf('<b>[%s]</b>', sprintf('User %s logged out', implode(' ', $infoEvento)));
                break;
            case 'handoff':
                return sprintf('<b>[%s]</b>', sprintf('User %s hands off presentation to user %s', $infoEvento[1], $infoEvento[2]));
                break;
            case 'recover':
                return sprintf('<b>[%s]</b>', sprintf('User %s takes back presentation', $infoEvento[1]));
                break;
            case 'uploadstart':
                return sprintf('<b>[%s]</b>', sprintf('User %s is uploading a document...', $infoEvento[1]));
                break;
            case 'uploadend':
                return sprintf('<b>[%s]</b>', sprintf('User %s finished uploading a document.', $infoEvento[1]));
                break;
            case 'uploadfail':
                return sprintf('<b>[%s]</b>', sprintf('User %s could not finish uploading a document.', $infoEvento[1]));
                break;
            default:
                return sprintf('<b>[UNPARSED: %s]</b>', $infoMensaje['mensaje']);
                break;
            }
        } else {
            return sprintf('%s', '<b>Invalid empty event</b>');
        }
    }
}

/** 
 * Procedimiento para recuperar la lista temporal de invitados:
    $listaInvitados = array(
        'chachalaca@example.com' => array(
            'nombre_invitado'   =>  'Soila Chacha Laca',
            'email_invitado'    =>  'chachalaca@example.com',
            ),
        'armandobronca@example.com' => array(
            'nombre_invitado'   =>  'Armando Bronca',
            'email_invitado'    =>  'armandobronca@example.com',
            ),
    );
 */
function recuperarListaTemporalInvitados()
{
    $sEregCorreo = "^[a-z0-9]+([\._\-]?[a-z0-9]+[_\-]?)*@[a-z0-9]+([\._\-]?[a-z0-9]+)*(\.[a-z0-9]{2,4})+$";
    $listaInvitados = array();
    if (isset($_POST['nombre_invitado']) && is_array($_POST['nombre_invitado']) &&
        isset($_POST['email_invitado']) && is_array($_POST['email_invitado'])) {
        for ($i = 0; $i < count($_POST['nombre_invitado']) && $i < count($_POST['email_invitado']); $i++) {
            $sNombreInvitado = trim($_POST['nombre_invitado'][$i]);
            $sEmailInvitado = trim($_POST['email_invitado'][$i]);
            if ($sNombreInvitado != '' && $sEmailInvitado != '') {
                if (ereg($sEregCorreo, $sEmailInvitado)) {
                    $listaInvitados[$sEmailInvitado] = array(
                        'nombre_invitado'   =>  $sNombreInvitado,
                        'email_invitado'    =>  $sEmailInvitado,
                    );
                }
            }
        }
    }
    return $listaInvitados;
}

function viewFormCreateConference($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf, $arrLang, $bEmbedded)
{
    include_once "modules/$module_name/libs/paloSantoCreateConference.class.php";
    $pCreateConference = new paloSantoCreateConference($pDB);
    $arrFormCreateConference = conferenceroom_createFieldForm($arrLang);
    $oForm = new paloForm($smarty,$arrFormCreateConference);
    while(true)
    {
        $number = rand(0,99999);
        $existe = $pCreateConference->existeroomNo($number);
        if(!$existe)
        {
            $_POST['phonenum'] = $number;
            break;
        }
    }
    // Verificar si se tiene disponible la base cbmysql
    $bExisteCBMysql = $pCreateConference->testMeetmeDatabase();
    $smarty->assign('cbmysql_support', $bExisteCBMysql ? 1 : 0);

    //begin, Form data persistence to errors and other events.
    $_DATA  = $_POST;
    $action = getParameter("action");
    $id     = getParameter("id");
    $smarty->assign("ID", $id); //persistence id with input hidden in tpl

    if($action=="view")
        $oForm->setViewMode();
    else if($action=="view_edit" || getParameter("save_edit"))
        $oForm->setEditMode();
    //end, Form data persistence to errors and other events.

    if($action=="view" || $action=="view_edit"){ // the action is to view or view_edit.
        $dataCreateConference = $pCreateConference->getCreateConferenceById($id);
        if(is_array($dataCreateConference) & count($dataCreateConference)>0)
            $_DATA = $dataCreateConference;
        else{
            $smarty->assign("mb_title", $arrLang["Error get Data"]);
            $smarty->assign("mb_message", $pCreateConference->errMsg);
        }
    }

    $smarty->assign("SAVE", $arrLang["Save"]);
    $smarty->assign("EDIT", $arrLang["Edit"]);
    $smarty->assign("CANCEL", $arrLang["Cancel"]);
    $smarty->assign("REQUIRED_FIELD", $arrLang["Required field"]);
    $smarty->assign("IMG", "images/list.png");

    // Procesar lista de invitados, y remover si es necesario
    $listaInvitados = recuperarListaTemporalInvitados();
    if (isset($_POST['remove_invitado']) && isset($_POST['remover'])) {
        foreach ($_POST['remover'] as $sIndiceRemover) 
            if (isset($listaInvitados[$sIndiceRemover])) 
                unset($listaInvitados[$sIndiceRemover]);
    }

    // Preparar presentación y controles para grid
    $arrData = array();
    foreach ($listaInvitados as $sEmailInvitado => $tuplaInvitado) {
        $arrData[] = array(
            '<input type="checkbox" name="remover[]" value="'.htmlentities($sEmailInvitado, ENT_COMPAT, "UTF-8").'"/>',
            htmlentities($tuplaInvitado['nombre_invitado'], ENT_COMPAT, "UTF-8").'<input type="hidden" name="nombre_invitado[]" value="'.htmlentities($tuplaInvitado['nombre_invitado']).'"/>',
            htmlentities($tuplaInvitado['email_invitado'], ENT_COMPAT, "UTF-8").'<input type="hidden" name="email_invitado[]" value="'.htmlentities($tuplaInvitado['email_invitado'], ENT_COMPAT, "UTF-8").'"/>',
        );
    }
    $arrData[] = array(
        '<input type="submit" class="button" name="add_invitado" value="'.$arrLang['Add New Guest'].'" />',
        '<input type="text" class="input" name="nombre_invitado[]" size="32" maxlength="128"/>',
        '<input type="text" class="input" name="email_invitado[]" size="32" maxlength="128"/>', );
    $oGrid = new paloSantoGrid($smarty);
    $oGrid->pagingShow(false);
    $arrGrid = array("title"    => $arrLang['Guests for conference'],
                     "icon"     => "images/user.png",
                     "width"    => "100%",
                     'start'    => 0,
                     'end'      => count($arrData),
                     'total'    => count($arrData),
                     "columns"  => array(
                                         0 => array("name"      => '<input type="submit" class="button" name="remove_invitado" value="'.$arrLang['Remove Selected'].'"/>',
                                                    "property1" => ""),
                                         1 => array("name"      => $arrLang['Name/Nick'],
                                                    "property1" => ""),
                                         2 => array("name"      => $arrLang['E-Mail Address'],
                                                    "property1" => ""),
                                        )
                    );
    $smarty->assign(array(
        'LABEL_VOICE_CONFERENCE_BLANK'  =>  $arrLang['leave blank for presentation-only conference'],
    ));
    $smarty->assign('EMBEDDED', $bEmbedded);
    $htmlForm = $oForm->fetchForm("$local_templates_dir/form_create_conference.tpl",$arrLang["Create Conference"], $_DATA);
    $htmlGrid = $oGrid->fetchGrid($arrGrid, $arrData, $arrLang);
    if ($bEmbedded) 
        $content = $htmlForm.$htmlGrid;
    else
        $content = "<form  method='POST' style='margin-bottom:0;' action='?menu=$module_name'>".$htmlForm.$htmlGrid."</form>";

    return $content;
}

function validate_saveNewCreateConference($smarty, $arrLang)
{
    $bExito = FALSE;
    $arrFormCreateConference = conferenceroom_createFieldForm($arrLang);
    $oForm = new paloForm($smarty,$arrFormCreateConference);
    $listaInvitados = recuperarListaTemporalInvitados();
    if (count($listaInvitados) <= 0) {
        $smarty->assign("mb_title", $arrLang["Validation Error"]);
        $smarty->assign("mb_message", $arrLang['Must have at least one guest besides creator.']);
    } elseif(!$oForm->validateForm($_POST)) {
        // Validation basic, not empty and VALIDATION_TYPE 
        $smarty->assign("mb_title", $arrLang["Validation Error"]);
        $arrErrores = $oForm->arrErroresValidacion;
        $strErrorMsg = "<b>{$arrLang['The following fields contain errors']}:</b><br/>";
        if(is_array($arrErrores) && count($arrErrores) > 0){
            foreach($arrErrores as $k=>$v)
                $strErrorMsg .= "$k, ";
        }
        $smarty->assign("mb_message", $strErrorMsg);
    } else {
        $bExito = TRUE;
    }
    return $bExito;
}

function execute_saveNewCreateConference($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf, $arrLang, $bEmbedded)
{
    $content = '';

    include_once "modules/$module_name/libs/paloSantoCreateConference.class.php";
    
    $listaInvitados = recuperarListaTemporalInvitados();
    foreach($listaInvitados as $tuplaInvitado){
        if($tuplaInvitado['email_invitado'] == $_POST['creator_email']){
            $smarty->assign("mb_title", $arrLang['Conference creation error']);
            $smarty->assign("mb_message", $arrLang["Duplicate E-Mail notification in guest list."]);
            $content = viewFormCreateConference($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang, $bEmbedded);
            return array(false,$content);
        }
    }
    $idConf = NULL;
    $pCreateConference = new paloSantoCreateConference($pDB);
    $bExito = $pCreateConference->createConference(
        $_POST['room_name'],
        $_POST['agenda'],
        $_POST['duration_hours'],
        $idConf,
        isset($_POST['id_cbmysql_conference']) ? $_POST['id_cbmysql_conference'] : NULL); // <-- Sólo presente al embeber en PBX-->Conference
    if (!$bExito) {
        $smarty->assign("mb_title", $arrLang['Conference creation error']);
        $smarty->assign("mb_message", $pCreateConference->errMsg);
        $content = viewFormCreateConference($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang, $bEmbedded);
    } else {
        $smarty->assign("mb_title", $arrLang['Conference created.']);
        $smarty->assign("mb_message", $arrLang['Conference created successfully!']);

        // Crear los invitados a la conferencia
        foreach ($listaInvitados as $tuplaInvitado) {
            $idInvitado = NULL;
            $bExito = $pCreateConference->agregarInvitadoConferencia(
                $idConf, 
                $tuplaInvitado['email_invitado'], 
                NULL, 
                $tuplaInvitado['nombre_invitado'], 
                $idInvitado);
            if (!$bExito) {
                $smarty->assign("mb_title", $arrLang['Conference creation error']);
                $smarty->assign("mb_message", $pCreateConference->errMsg);
                break;
            }
        }
        if ($bExito) {
            $bExito = $pCreateConference->agregarInvitadoConferencia(
                $idConf, 
                $_POST['creator_email'], 
                NULL, 
                $_POST['creator_name'], 
                $idInvitado);
            if (!$bExito) {
                $smarty->assign("mb_title", $arrLang['Conference creation error']);
                $smarty->assign("mb_message", $pCreateConference->errMsg);
            } else {
                $pCreateConference->marcarInvitadoCreador($idConf, $idInvitado);
                $pCreateConference->marcarInvitadoPresentador($idConf, $idInvitado);
            }
        }
        
        // Se asume que en este punto $idInvitado es el ID del creador de la conferencia
        
        $sNumConf = NULL;
        if ($bExito && !isset($_POST['id_cbmysql_conference']) && isset($_POST['phonenum'])) {
            if (is_numeric($_POST['phonenum'])) {
                
                $sNumConf = $_POST['phonenum'];
                // Intentar la creación de la conferencia telefónica
                $bExito = $pCreateConference->crearConferenciaTelefonica(
                    $_POST['room_name'],
                    $_POST['duration_hours'],
                    $_POST['phonenum'],$idConf);  // CB: Se envie el id de la conferencia recien creada.
                if (!$bExito) {
                    $smarty->assign("mb_title", $arrLang['Conference creation error']);
                    $smarty->assign("mb_message", $pCreateConference->errMsg);
                }
            }
        }
        
        if ($bExito) {
            $pCreateConference->enviarCorreoInvitacion($idConf, NULL, $sNumConf);

            $smarty->assign(array(
                'ID_CONFERENCIA'    =>  $idConf,
                'room_name'         =>  $_POST['room_name'],
                'agenda'         =>  $_POST['agenda'],
                'duration_hours'         =>  $_POST['duration_hours'],
                'ID_ADMIN'         =>  $idInvitado,
            ));
            $content = $smarty->fetch("$local_templates_dir/create_conf_success.tpl");;
        } else {
            $content = viewFormCreateConference($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang, $bEmbedded);
        }
    }
    return array($bExito, $content);
}

function saveNewCreateConference($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf, $arrLang, $bEmbedded)
{
    if (!validate_saveNewCreateConference($smarty, $arrLang)) {
        // Se ha asignado un mensaje de error
        $content = viewFormCreateConference($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang, $bEmbedded);
    } else {
        $res = execute_saveNewCreateConference($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang, $bEmbedded);
        $content = $res[1];
    }
    return $content;
}

function conferenceroom_createFieldForm($arrLang)
{
    $arrOptions = array('val1' => 'Value 1', 'val2' => 'Value 2', 'val3' => 'Value 3');

    $arrFields = array(
            "room_name"   => array(      "LABEL"                  => $arrLang["Room Name"],
                                            "REQUIRED"               => "si",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "agenda"   => array(      "LABEL"                  => $arrLang["Agenda"],
                                            "REQUIRED"               => "si",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "duration_hours"   => array(      "LABEL"                  => $arrLang["Duration (hours)"],
                                            "REQUIRED"               => "si",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "numeric",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "creator_name"   => array(      "LABEL"                  => $arrLang['Name or Nick of Creator'],
                                            "REQUIRED"               => "si",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "text",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            "creator_email"   => array(      "LABEL"                  => $arrLang['E-Mail for Creator'],
                                            "REQUIRED"               => "si",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "email",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),

            "phonenum"   => array(      "LABEL"                  => $arrLang['Phone number for phone conference'],
                                            "REQUIRED"               => "no",
                                            "INPUT_TYPE"             => "TEXT",
                                            "INPUT_EXTRA_PARAM"      => "",
                                            "VALIDATION_TYPE"        => "numeric",
                                            "VALIDATION_EXTRA_PARAM" => ""
                                            ),
            );
    return $arrFields;
}

?>
