<?php
  /* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 1.6-5                                               |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: paloSantoCreateConference.class.php,v 1.1 2009-06-29 08:06:40 Alex Villacís Lasso a_villacis@palosanto.com Exp $ */

class paloSantoConferenceChat
{
    var $_DB;
    var $errMsg;

    function paloSantoConferenceChat(&$pDB)
    {
        // Se recibe como parámetro una referencia a una conexión paloDB
        if (is_object($pDB)) {
            $this->_DB =& $pDB;
            $this->errMsg = $this->_DB->errMsg;
        } else {
            $dsn = (string)$pDB;
            $this->_DB = new paloDB($dsn);

            if (!$this->_DB->connStatus) {
                $this->errMsg = $this->_DB->errMsg;
                // debo llenar alguna variable de error
            } else {
                // debo llenar alguna variable de error
            }
        }
    }

    function leerLogChat($idConf, $idUltimoMsg = -1)
    {
        if (!ereg('^[[:digit:]]+$', "$idConf")) {
            $this->errMsg = 'Invalid conference ID';
            return NULL;
        }
        if ($idUltimoMsg != -1 && !ereg('^[[:digit:]]+$', "$idUltimoMsg")) {
            $this->errMsg = 'Invalid restart sequence number';
            return NULL;
        }
        $sPeticionSQL = 'SELECT id_secuencia, nick, fecha, mensaje FROM chatlog LEFT JOIN invitado ON chatlog.id_conferencia = invitado.id_conferencia AND chatlog.id_invitado = invitado.id_invitado WHERE chatlog.id_conferencia = ? AND id_secuencia > ? ORDER BY id_secuencia';
        $recordset = $this->_DB->fetchTable($sPeticionSQL, TRUE, array($idConf, $idUltimoMsg));
        if (!is_array($recordset)) {
            $this->errMsg = 'Could not fetch chat log - '.$this->_DB->errMsg;
            return NULL;
        }
        return $recordset;
    }

    function agregarMensajeChat($idConf, $idInvitado, $sMensaje)
    {
        if (!ereg('^[[:digit:]]+$', "$idConf")) {
            $this->errMsg = 'Invalid conference ID';
            return NULL;
        }
        $sPeticionSQL = 'INSERT INTO chatlog (id_conferencia, id_invitado, fecha, mensaje) VALUES (?, ?, ?, ?)';
        $result = $this->_DB->genQuery($sPeticionSQL, array($idConf, $idInvitado, date('Y-m-d H:i:s'), "$sMensaje"));
        if (!$result) {
            $this->errMsg = 'Could not insert chat message - '.$this->_DB->errMsg;
            return FALSE;
        }
        if (!is_null($idInvitado)) {
            $this->actualizarActividad($idConf, $idInvitado);
        }
        return TRUE;
    }
    
    function actualizarActividad($idConf, $idInvitado)
    {
        $sPeticionSQL = 'UPDATE invitado SET logoneado = 1, fecha_ultima_actividad = ? WHERE id_conferencia = ? AND id_invitado = ?';
        $result = $this->_DB->genQuery($sPeticionSQL, array(date('Y-m-d H:i:s'), $idConf, $idInvitado));
        if (!$result) {
            $this->errMsg = 'Could not update activity - '.$this->_DB->errMsg;
            return FALSE;
        }
        return TRUE;
    }
    
    function agregarEventoChat($idConf, $sEvent)
    {
        return $this->agregarMensajeChat($idConf, NULL, $sEvent);
    }
}
?>
