<?php
  /* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 1.6-5                                               |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: index.php,v 1.1 2009-06-29 08:06:35 Alex Villacís Lasso a_villacis@palosanto.com Exp $ */
//include elastix framework
include_once "libs/paloSantoGrid.class.php";
include_once "libs/paloSantoForm.class.php";

function _moduleContent(&$smarty, $module_name)
{
    //include module files
    include_once "modules/$module_name/configs/default.conf.php";
    include_once "modules/$module_name/libs/paloSantoPresentation.class.php";
    include_once "modules/conferenceroom_docrepo/libs/paloSantoDocumentViewer.class.php";
    include_once "modules/conferenceroom_list/libs/paloSantoConferenceChat.class.php";

    //include file language agree to elastix configuration
    //if file language not exists, then include language by default (en)
    $lang=get_language();
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    $lang_file="modules/$module_name/lang/$lang.lang";
    include_once "modules/$module_name/lang/en.lang";
    if (file_exists("$base_dir/$lang_file")) {
        $arrLangEN = $arrLangModule;
        include_once "$lang_file";
        $arrLangModule = array_merge($arrLangEN, $arrLangModule);
    }

    // TODO: traducir
    if (!isset($_SESSION['elastix_conference_id'])) return "(internal) No conference has been selected!";

    $smarty->assign('MODULE_NAME', $module_name);

    //global variables
    global $arrConf;
    global $arrConfModule;
    global $arrLang;
    global $arrLangModule;
    $arrConf = array_merge($arrConf,$arrConfModule);
    $arrLang = array_merge($arrLang,$arrLangModule);

    //folder path for custom templates
    $templates_dir=(isset($arrConf['templates_dir']))?$arrConf['templates_dir']:'themes';
    $local_templates_dir="$base_dir/modules/$module_name/".$templates_dir.'/'.$arrConf['theme'];

    global $_copy_module_name;
//    $GLOBALS['pDBModule'] = $pDB;
    $GLOBALS['module_dsn'] = $arrConf['dsn_conn_database'];
    $_copy_module_name = $module_name;
    $xAjax = getXajax();
    $xAjax->waitCursorOff();
    $xAjax->registerFunction('docView_updatePageNumber');
    $xAjax->registerFunction('docView_navigatePage');
    $xAjax->processRequests();
    $smarty->assign("SCRIPT_AJAX", $xAjax->printJavascript("libs/xajax/"));

    //conexion resource
    $pDB = new paloDB($arrConf['dsn_conn_database']);

    $smarty->assign('title', $arrLang['Interactive Document Presentation']);
    $content = '';
    if (isset($_POST['upload'])) 
         $sAction = 'upload_doc';
    else $sAction = getParameter('action');
    switch ($sAction)
    {
    case 'display_img':
        $content = mostrarPaginaDocumento($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang);
        break;
    case 'upload_doc':
        $content = cargarNuevoDocumento($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang);
    default:
        // Este caso maneja la visualización del documento convertido en sí
        $content .= visualizarDocumento($smarty, $module_name, $local_templates_dir, $pDB, $arrConf, $arrLang);
    }


    return $content;
}

function cargarNuevoDocumento($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf, $arrLang)
{
    $sContenido = '';

    if ($_FILES['upload_file']['error'] != 0) {
        $smarty->assign("mb_title", $arrLang['Problem while uploading file']);
        switch ($_FILES['upload_file']['error']) {
        case  UPLOAD_ERR_INI_SIZE:
            $smarty->assign("mb_message", $arrLang['Uploaded file is larger than allowed by PHP configuration.']);
            break;
        case UPLOAD_ERR_INI_SIZE:
            $smarty->assign("mb_message", $arrLang['Uploaded file is larger than allowed by PHP configuration.']);
            break;
        case UPLOAD_ERR_FORM_SIZE:
            $smarty->assign("mb_message", $arrLang['Uploaded file is larger than allowed by MAX_FILE_SIZE.']);
            break;
        case UPLOAD_ERR_PARTIAL:
            $smarty->assign("mb_message", $arrLang['File was only partially uploaded.']);
            break;
        case UPLOAD_ERR_NO_FILE:
            $smarty->assign("mb_message", $arrLang['No file was specified for upload.']);
            break;
        case UPLOAD_ERR_NO_TMP_DIR:
            $smarty->assign("mb_message", $arrLang['No PHP temporary folder configured. Check PHP configuration.']);
            break;
        case UPLOAD_ERR_CANT_WRITE:
            $smarty->assign("mb_message", $arrLang['Unable to write temporary (not enough disk space, or access denied).']);
            break;
        case  8:    //  UPLOAD_ERR_EXTENSION  
            $smarty->assign("mb_message", 'Uploaded file blocked by forbidden file extension.');
            break;
        }
    } else {
        $idNuevoDoc = NULL;
        $pDocumentViewer = new paloSantoDocumentViewer($pDB);
        $pChat = new paloSantoConferenceChat($pDB);

        // Se cierra la sesión para que el evento AJAX pueda responder
        $local_elastix_conference_id = $_SESSION['elastix_conference_id'];
        $local_elastix_user = $_SESSION['elastix_user_id'];
        $local_elastix_usernick = $_SESSION['elastix_user_nick'];
        session_commit();

        $pChat->agregarEventoChat(
            $local_elastix_conference_id, 
            'uploadstart '.$local_elastix_usernick);

        $bExito = $pDocumentViewer->processUploadedFile(
            $_FILES['upload_file'], 
            $arrConf['docimgs_dir'], 
            $local_elastix_conference_id, 
            $idNuevoDoc);
        if (!$bExito) {
            $smarty->assign("mb_title", $arrLang['Failed to convert document']);
            $smarty->assign("mb_message", $pDocumentViewer->errMsg);
            $pChat->agregarEventoChat(
                $local_elastix_conference_id, 
                'uploadfail '.$local_elastix_user);
        } else {
            $smarty->assign("mb_title", $arrLang['Document converted successfully']);
            $smarty->assign("mb_message", $arrLang['Document converted, redirecting to document...']);

            $pDocPresentation = new paloSantoPresentation($pDB);
            $bExito = $pDocPresentation->setCurrentPresentation($local_elastix_conference_id, $idNuevoDoc);
            if (!$bExito) {
                $smarty->assign("mb_title", $arrLang['Unable to set presentation']);
                $smarty->assign("mb_message", $pDocPresentation->errMsg);
            } else {
                $smarty->assign("mb_title", $arrLang['Document converted successfully']);
                $smarty->assign("mb_message", $arrLang['Document converted, redirecting to document...']);
                if (isset($_POST['id_documento'])) $_POST['id_documento'] = $idNuevoDoc;
                Header("Location: ?menu=$module_name&action=display_doc&id_documento=$idNuevoDoc");
            }
            $pChat->agregarEventoChat(
                $local_elastix_conference_id, 
                'uploadend '.$local_elastix_usernick);
        }
    }
    return $sContenido;
}

function visualizarDocumento($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf, $arrLang)
{
    $smarty->assign("IMG", "images/list.png");
    $smarty->assign('MODULE_NAME', $module_name);

    $pDocumentViewer = new paloSantoDocumentViewer($pDB);
    $pDocPresentation = new paloSantoPresentation($pDB);
    $pChat = new paloSantoConferenceChat($pDB);
    $idDocumento = NULL;
    $infoDoc = $pDocPresentation->getPresentationInfo($_SESSION['elastix_conference_id']);
    if (!is_null($infoDoc)) {
        $idDocumento = $infoDoc['id_documento'];
    }

    // Leer la lista de documentos
    $listaDoc = $pDocumentViewer->getDocumentList($_SESSION['elastix_conference_id']);
    if (!is_array($listaDoc)) {
        $smarty->assign("mb_title", $arrLang['Cannot display document']);
        $smarty->assign("mb_message", $pDocumentViewer->errMsg);
    } else {
        if (count($listaDoc) > 0) {
            $ids = array_keys($listaDoc);
            if (is_null($idDocumento)) {
                $idDocumento = $ids[0];
                if (!$pDocPresentation->setCurrentPresentation($_SESSION['elastix_conference_id'], $idDocumento)) {
                    $smarty->assign("mb_title", $arrLang['Cannot display document']);
                    $smarty->assign("mb_message", $pDocPresentation->errMsg);
                    $idDocumento = NULL;
                } else {
                    $infoDoc = $pDocPresentation->getPresentationInfo($_SESSION['elastix_conference_id']);
                    if (is_null($infoDoc)) {
                        $smarty->assign("mb_title", $arrLang['Cannot display document']);
                        $smarty->assign("mb_message", $pDocPresentation->errMsg);
                        $idDocumento = NULL;
                    }
                }
            }
        }
        $smarty->assign('LISTA_DOCS_CONF', $listaDoc);
    }
    $infoDoc['usuario_control'] = $pDocPresentation->getCurrentPresentator($_SESSION['elastix_conference_id']);
    if (!is_null($idDocumento)) {
        //$infoDoc = $pDocumentViewer->getDocumentInfo($_SESSION['elastix_conference_id'], $idDocumento);
        if (!is_array($infoDoc)) {
            $smarty->assign("mb_title", $arrLang['Cannot display document']);
            $smarty->assign("mb_message", $pDocumentViewer->errMsg);
        } else {
            $iPagina = $infoDoc['pag_actual']; 
            if (is_null($iPagina)) $iPagina = 1;
            if ($iPagina > $infoDoc['num_paginas']) $iPagina = $infoDoc['num_paginas'];
            if ($iPagina < 1) $iPagina = 1;
        
            $listaUsuarios = $pDocPresentation->getUserList($_SESSION['elastix_conference_id']);
            $sUsuarioHost = $pDocPresentation->getCurrentHost($_SESSION['elastix_conference_id']);
            $listaHandoff = array();
            foreach ($listaUsuarios as $tuplaUsuario) {
                $sLabel = $tuplaUsuario['nick'];
                if ($tuplaUsuario['es_creador']) $sLabel .= ' (host)';
                if ($tuplaUsuario['es_presentador']) $sLabel .= ' (pres)';
                $listaHandoff[$tuplaUsuario['id_invitado']] = $sLabel;
            }        

            // Opciones que sólo funcionan si el usuario es dueño del documento.
            if ($infoDoc['usuario_control'] == $_SESSION['elastix_user_id']) {
                if (isset($_POST['id_documento']) && $infoDoc['id_documento'] != $_POST['id_documento']) {
                    // Cambiar de documento presentado
                    $pDocPresentation->setCurrentPresentation($_SESSION['elastix_conference_id'], $_POST['id_documento']);
                } elseif (isset($_POST['delete'])) {
                    $bExito = $pDocumentViewer->deleteDocument($_SESSION['elastix_conference_id'], $idDocumento);
                    if ($bExito) {
                        // Leer la lista de documentos
                        $listaDoc = $pDocumentViewer->getDocumentList($_SESSION['elastix_conference_id']);
                        if (!is_array($listaDoc)) {
                            $smarty->assign("mb_title", $arrLang['Cannot display document']);
                            $smarty->assign("mb_message", $pDocumentViewer->errMsg);
                        } else {
                            if (count($listaDoc) > 0) {
                                $ids = array_keys($listaDoc);
                                $idDocumento = $ids[0];
                                $bExito = $pDocPresentation->setCurrentPresentation($_SESSION['elastix_conference_id'], $idDocumento);
                                if (!$bExito) {
                                    $smarty->assign("mb_title", $arrLang['Cannot display document']);
                                    $smarty->assign("mb_message", $pDocPresentation->errMsg);
                                }
                            }
                            $smarty->assign('LISTA_DOCS_CONF', $listaDoc);
                        }
                        Header('Location: ?menu='.$module_name);
                    } else {
                        $smarty->assign("mb_title", $arrLang['Cannot remove document']);
                        $smarty->assign("mb_message", $pDocumentViewer->errMsg);
                    }
                } elseif (isset($_POST['handoff']) && $infoDoc['usuario_control'] != $_POST['handoff']) {
                    if (isset($listaHandoff[$_POST['handoff']])) {
                        $pDocPresentation->handOffToUser($_SESSION['elastix_conference_id'], $_POST['handoff']);
                        $pChat->agregarEventoChat(
                            $_SESSION['elastix_conference_id'], 
                            'handoff '.$_SESSION['elastix_user_id'].' '.$_POST['handoff']);
                    }
                } elseif (isset($_POST['first'])) $pDocPresentation->selectFirstPage($idDocumento);
                elseif (isset($_POST['prev'])) $pDocPresentation->selectPrevPage($idDocumento);
                elseif (isset($_POST['next'])) $pDocPresentation->selectNextPage($idDocumento);
                elseif (isset($_POST['last'])) $pDocPresentation->selectLastPage($idDocumento);
                elseif (isset($_POST['new_page'])) $pDocPresentation->selectPageByNumber($idDocumento, $_POST['new_page']);

                // Refrescar todos los datos
                $infoDoc = $pDocPresentation->getPresentationInfo($_SESSION['elastix_conference_id']);
                $idDocumento = $infoDoc['id_documento'];
                $infoDoc['usuario_control'] = $pDocPresentation->getCurrentPresentator($_SESSION['elastix_conference_id']);
                $iPagina = $infoDoc['pag_actual']; 
                if (is_null($iPagina)) $iPagina = 1;
                if ($iPagina > $infoDoc['num_paginas']) $iPagina = $infoDoc['num_paginas'];
                if ($iPagina < 1) $iPagina = 1;

            }

            if ($sUsuarioHost == $_SESSION['elastix_user_id']) {
                $smarty->assign('IS_OWNER', 1);
                if (isset($_POST['recover']) && $infoDoc['usuario_control'] != $sUsuarioHost) {
                    $pDocPresentation->handOffToUser($_SESSION['elastix_conference_id'], $sUsuarioHost);
                    $infoDoc['usuario_control'] = $pDocPresentation->getCurrentPresentator($_SESSION['elastix_conference_id']);
                    $pChat->agregarEventoChat(
                        $_SESSION['elastix_conference_id'], 
                        'recover '.$_SESSION['elastix_user_nick']);
                }
            }

            $listaUsuarios = $pDocPresentation->getUserList($_SESSION['elastix_conference_id']);
            $sUsuarioHost = $pDocPresentation->getCurrentHost($_SESSION['elastix_conference_id']);
            $listaHandoff = array();
            $sNickControl = '(unknown)';
            foreach ($listaUsuarios as $tuplaUsuario) {
                $sLabel = $tuplaUsuario['nick'];
                if ($tuplaUsuario['es_creador']) $sLabel .= ' (host)';
                if ($tuplaUsuario['es_presentador']) $sLabel .= ' (pres)';
                $listaHandoff[$tuplaUsuario['id_invitado']] = $sLabel;
                if ($infoDoc['usuario_control'] == $tuplaUsuario['id_invitado'])
                    $sNickControl = $tuplaUsuario['nick'];
            }        

            $smarty->assign('ID_DOCUMENTO', $idDocumento);
            $smarty->assign(array(
                'DOCUMENT_NAME' =>  $infoDoc['nombre_doc'],
                'CUR_PAGE' =>  $iPagina,
                'PREV_PAGE' =>  ($iPagina > 1 ? $iPagina - 1 : 1),
                'NEXT_PAGE' =>  ($iPagina < $infoDoc['num_paginas'] ? $iPagina + 1 : $infoDoc['num_paginas']),
                'TOTAL_PAGES' =>  $infoDoc['num_paginas'],
                'CURR_OWNER' =>  $infoDoc['usuario_control'],
                'CURR_OWNER_NICK' =>  $sNickControl,
                'CAN_NAVIGATE' =>  ($infoDoc['usuario_control'] == $_SESSION['elastix_user_id']) ? 1 : 0,
                'handoff_users' => $listaHandoff,
                
            ));

            // Construir arreglo de números de página
            $page_numbers = array();
            for ($i = 1; $i <= $infoDoc['num_paginas']; $i++) $page_numbers[$i] = $i;
            $smarty->assign('page_numbers', $page_numbers);

        }
    } else {
        $smarty->assign('LISTA_DOCS_CONF', array("" => $arrLang['-No documents uploaded-']));
        $smarty->assign('CAN_NAVIGATE', ($infoDoc['usuario_control'] == $_SESSION['elastix_user_id']) ? 1 : 0);
    }
    $smarty->assign(array(
        'label_handoff' =>  $arrLang['Hand off to'],
        'label_removedoc'   =>  $arrLang['Remove document'],
        'label_document'    =>  $arrLang['Document'],
        'label_page'        =>  $arrLang['Page'],
        'label_curr_owner'  =>  $arrLang['Current owner'],
        'label_back'        =>  $arrLang['Back'],
        'label_upload_new_file' => $arrLang['Upload new file'],
        'label_upload'      =>  $arrLang['Upload'],
        'label_regain_control'=> $arrLang['Regain Control'],
        'no_document_uploaded' => $arrLang['No document uploaded for presentation'],
        'no_doc_selected'   =>  $arrLang['No document selected for viewing'],
    ));
    $sContenido = $smarty->fetch("$local_templates_dir/form.tpl");
    return $sContenido;
}

function mostrarPaginaDocumento($smarty, $module_name, $local_templates_dir, &$pDB, $arrConf, $arrLang)
{
    $sContenido = "";
    $idDocumento = NULL;

    $pDocumentViewer = new paloSantoDocumentViewer($pDB);
    $pDocPresentation = new paloSantoPresentation($pDB);
    $idDocumento = NULL;
    $infoPresentation = $pDocPresentation->getPresentationInfo($_SESSION['elastix_conference_id']);
    if (!is_null($infoPresentation)) {
        $idDocumento = $infoPresentation['id_documento'];
    }

    if (!is_null($idDocumento)) {
        if (!is_array($infoPresentation)) {
            $sContenido .= "Unable to fetch document info - ".$pDocumentViewer->errMsg;
        } else {
            $iPagina = $infoPresentation['pag_actual'];
            if ($iPagina > $infoPresentation['num_paginas']) $iPagina = $infoPresentation['num_paginas'];
            if ($iPagina < 1) $iPagina = 1;
            $sNombreImagen = sprintf('%s/image-%d.jpg', $infoPresentation['ruta_directorio_imgs'], $iPagina - 1);
            if (!file_exists($sNombreImagen) && $infoPresentation['num_paginas'] == 1)
                $sNombreImagen = sprintf('%s/image.jpg', $infoPresentation['ruta_directorio_imgs']);
            if (!file_exists($sNombreImagen)) {
                $sContenido .= "(internal) Unable to read file $sNombreImagen.";
            } else {
/*
	    header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	    header("Last-Modified: " . gmdate("D, d M Y H:i:s") . "GMT");
	    header("Cache-Control: no-cache, must-revalidate");
	    header("Pragma: no-cache");
*/

                // TODO: forzar a no cachear el documento en browser
                $sContenido = file_get_contents($sNombreImagen);
//                Header('Content-Length: '.strlen($sContenido));
                Header('Content-type: image/jpeg');
//                Header('Pragma: no-cache');
            }
        }
    }
    return $sContenido;
}

/**
 * Procedimiento registrado por XAJAX. Cada segundo, se invoca este método con
 * el ID del documento y el número de página que se muestran en el navegador. 
 * Si la página para el documento indicado difiere de la página informada, se
 * procede a mandar el refresco de la página.
 */
function docView_updatePageNumber($idDocumento, $iPaginaActual, $sUsuarioControl)
{
    global $_copy_module_name;
    $respuesta = new xajaxResponse();

    $iTimeoutPoll = 5 * 60;
    
    // Problemas con MSIE al haber más de un AJAX con respuesta larga
    if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE ') !== false) {
        $iTimeoutPoll = 2;
    }

    /* El comportamiento por omisión de la sesión por PHP bloquea el session_start()
       mientras otro cliente use la misma sesión. Esto impide que se ejecuten cambios
       de página mientras el método AJAX todavía no responde. Para prevenir esto, se
       hace una copia de los datos requeridos de la sesión, y luego se libera la
       sesión. 
     */
    $local_elastix_conference_id = $_SESSION['elastix_conference_id'];
    session_commit();
    
    set_time_limit(0);
    $bContinuar = TRUE;
    $iTimestampInicio = time();
    $pDB = new paloDB($GLOBALS['module_dsn']);
    $pDocumentViewer = new paloSantoDocumentViewer($pDB);
    $pDocPresentation = new paloSantoPresentation($pDB);
    while ($bContinuar && time() - $iTimestampInicio <  $iTimeoutPoll) {

        $infoDoc = $pDocPresentation->getPresentationInfo($local_elastix_conference_id);
        if (!is_array($infoDoc)) {
            $listaDoc = $pDocumentViewer->getDocumentList($local_elastix_conference_id);
            if (is_array($listaDoc) && count($listaDoc) > 0) {
                $respuesta->addScript("alert(\"(internal) getPresentationInfo() failed - $pDocPresentation->errMsg\");");
                $bContinuar = FALSE;
                return $respuesta;
            }
        } else {
            $infoDoc['usuario_control'] = $pDocPresentation->getCurrentPresentator($local_elastix_conference_id);
            if ($infoDoc['id_documento'] != $idDocumento || $sUsuarioControl != $infoDoc['usuario_control']) {
                // Se requiere refrescar para mandar los controles de página al otro usuario
                $respuesta->addAssign('id_documento', 'value', $infoDoc['id_documento']);
                $respuesta->addScript("document.getElementById('frm_doc_view').submit();");
                $bContinuar = FALSE;
            } elseif ($infoDoc['pag_actual'] != $iPaginaActual) {
                $sURL = "?module=$_copy_module_name&rawmode=yes&action=display_img&id_documento=$idDocumento&id_pagina=$infoDoc[pag_actual]&ext=.jpg";
                // 
                $respuesta->addAssign('img_documento', 'src', $sURL);
                $respuesta->addAssign('pagina_actual', 'value', $infoDoc['pag_actual']);
                $respuesta->addAssign('cur_page_static', 'innerHTML', $infoDoc['pag_actual']);
                $bContinuar = FALSE;
            } else {
            }
        }
        if ($bContinuar) {
            // Esperar medio segundo
            time_nanosleep(0, 500000000);
        }
    }
    
    $respuesta->addScript("setTimeout(\"queryCurrentPage()\", 1);");
    $pDocumentViewer = NULL;
    $pDB->conn = NULL;
    $pDB = NULL;
    return $respuesta;
}

/**
 * Procedimiento registrado por XAJAX. Al recibir el comando correspondiente, o
 * un número de página, procede a cambiar a la página indicada.
 */
function docView_navigatePage($sComandoPagina)
{
    global $_copy_module_name;
    $respuesta = new xajaxResponse();

    $pDB = new paloDB($GLOBALS['module_dsn']);
    $pDocumentViewer = new paloSantoDocumentViewer($pDB);
    $pDocPresentation = new paloSantoPresentation($pDB);

    $idDocumento = NULL;
    $infoPresentation = $pDocPresentation->getPresentationInfo($_SESSION['elastix_conference_id']);
    if (!is_null($infoPresentation)) {
        $idDocumento = $infoPresentation['id_documento'];
    }

    if (!is_null($idDocumento)) {
        if ($sComandoPagina == 'first') $pDocPresentation->selectFirstPage($idDocumento);
        elseif ($sComandoPagina == 'prev') $pDocPresentation->selectPrevPage($idDocumento);
        elseif ($sComandoPagina == 'next') $pDocPresentation->selectNextPage($idDocumento);
        elseif ($sComandoPagina == 'last') $pDocPresentation->selectLastPage($idDocumento);
        elseif (ereg('^[[:digit:]]+$', $sComandoPagina)) $pDocPresentation->selectPageByNumber($idDocumento, $sComandoPagina);
        
        // Actualizar la lista desplegable, en caso de existir alguna
        $infoPresentation = $pDocPresentation->getPresentationInfo($_SESSION['elastix_conference_id']);
        $sCambioPaginaSelect = <<<CAMBIO_PAGINA_SELECT
var select_new_page = document.getElementById('new_page');
if (select_new_page != null) { select_new_page.value = '{$infoPresentation['pag_actual']}'; }
CAMBIO_PAGINA_SELECT;
        $respuesta->addScript($sCambioPaginaSelect);
//        $respuesta->addAssign('pagina_actual', 'value', $infoDoc['pag_actual']);
    }
    return $respuesta;
}

?>
